<?xml version="1.0"?>
<xsl:stylesheet version = "1.0" 
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:imsvdex="http://www.imsglobal.org/xsd/imsvdex_v1p0"
 exclude-result-prefixes="imsvdex">

<xsl:output method="xml" indent="yes"/>
	
	<xsl:template match="imsvdex:root">
		<xsl:apply-templates/>
	</xsl:template>
	
	<xsl:template match="imsvdex:vdex">
		<begin>	
			<xsl:apply-templates select="//imsvdex:term[imsvdex:caption]"/>			
		</begin>
	</xsl:template>
	
	<xsl:template match="imsvdex:term[imsvdex:caption]">
		<xsl:apply-templates select="imsvdex:caption[imsvdex:langstring]"/>
	</xsl:template>	
	
	<xsl:template match="imsvdex:caption[imsvdex:langstring]">
		<item>
			<xsl:value-of select="imsvdex:langstring"/>
		</item>
	</xsl:template>

</xsl:stylesheet>

