<%@page import = "uk.ac.reload.scormplayer.server.sequence.*,uk.ac.reload.scormplayer.server.*,java.util.*,uk.ac.reload.scormplayer.server.manager.*"%>
<%
/**
  *  RELOAD SCORM Runtime Environment - A SCORM package runtime player
  *
  *  Copyright (c) 2003 Oleg Liber, Bill Olivier, Phillip Beauvoir, Paul Sharples
  *
  *  Permission is hereby granted, free of charge, to any person obtaining a copy
  *  of this software and associated documentation files (the "Software"), to deal
  *  in the Software without restriction, including without limitation the rights
  *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  *  copies of the Software, and to permit persons to whom the Software is
  *  furnished to do so, subject to the following conditions:
  *
  *  The above copyright notice and this permission notice shall be included in
  *  all copies or substantial portions of the Software.
  *
  *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  *
  *  Project Management Contact:
  *
  *  Oleg Liber
  *  Bolton Institute of Higher Education
  *  Deane Road
  *  Bolton BL3 5AB
  *  UK
  *
  *  e-mail:   o.liber@bolton.ac.uk
  *
  *
  *  Technical Contact:
  *
  *  Phillip Beauvoir
  *  e-mail:   p.beauvoir@bolton.ac.uk
  *
  *  Web:      http://www.reload.ac.uk
  *
  */
%>
<html>
<head>
<script language="javascript">
<!--
// Function to take existing cmi model from LMSFrame and submit that data as a
// form, which the can be accessed by JSP and saved back into the server model
function updateServerCMIModel(){
	formstring = top.window.LMSFrame.showCurrentModelState("form");
	document.forms.update.data.value = formstring;
	document.forms.update.submit();
}


function docompletedAsset(sco){
    document.forms.asset.status.value = sco;
	document.forms.asset.submit();
}
//-->
</script>
</head>
<body bgcolor="#ffffff">
<%
/*
* We need to take the form data that was posted, split it into constituent parts
* and then store that as a 2-D array, which is sent back to the server model
*/
ScormManager theCourse = ScormLaunch.PackageToPlay;

String assetCompleted = (String)request.getParameter("status");
if (assetCompleted != null){
    if (assetCompleted != null){
        theCourse.updateNavStatus(assetCompleted, "completed");
    }
}

String status = "";
String scoData = (String)request.getParameter("data");
if (scoData != "" && scoData != null){
    String currentSco = theCourse._sequence.getCurrentSco();
    String[] cmiBits = scoData.split("\\^");
    String[][] cmicomponents = new String[cmiBits.length][2];
    for(int i=0; i < cmiBits.length; i++){
       String[] cmiNameValue = cmiBits[i].split("\\~");
       cmicomponents[i][0] = cmiNameValue[0];
       if (cmiNameValue[0].equals("cmi.core.lesson_status")){
               status = cmiNameValue[1];
       }
       if (cmiNameValue.length > 1)
           cmicomponents[i][1] = cmiNameValue[1];
       else
           cmicomponents[i][1] = "";
    }
    try{
        theCourse.updateNavStatus(currentSco, status);
        theCourse._sequence.getItem(currentSco).updateClientModel(cmicomponents);

    } catch (Exception ex){
        System.out.println("Error updating package sco info.");
    }
}
%>
<form name="update" method="post" action="LMSUpdate.jsp">
	<input type="hidden" name="data" value="">
</form>

<form name="asset" method="post" action="LMSUpdate.jsp">
	<input type="hidden" name="status" value="">
</form>

</body>
</html>