<%@page import = "uk.ac.reload.scormplayer.server.*,java.io.*,java.util.*,org.jdom.*,uk.ac.reload.scormplayer.server.manager.*"%>
<%
/**
  *  RELOAD SCORM Runtime Environment - A SCORM package runtime player
  *
  *  Copyright (c) 2003 Oleg Liber, Bill Olivier, Phillip Beauvoir, Paul Sharples
  *
  *  Permission is hereby granted, free of charge, to any person obtaining a copy
  *  of this software and associated documentation files (the "Software"), to deal
  *  in the Software without restriction, including without limitation the rights
  *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  *  copies of the Software, and to permit persons to whom the Software is
  *  furnished to do so, subject to the following conditions:
  *
  *  The above copyright notice and this permission notice shall be included in
  *  all copies or substantial portions of the Software.
  *
  *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  *
  *  Project Management Contact:
  *
  *  Oleg Liber
  *  Bolton Institute of Higher Education
  *  Deane Road
  *  Bolton BL3 5AB
  *  UK
  *
  *  e-mail:   o.liber@bolton.ac.uk
  *
  *
  *  Technical Contact:
  *
  *  Phillip Beauvoir
  *  e-mail:   p.beauvoir@bolton.ac.uk
  *
  *  Web:      http://www.reload.ac.uk
  *
  */
%>
<%
ScormManager theCourse = ScormLaunch.PackageToPlay;

if (theCourse.isTreeVisible()){
    String[][] manifestMenu = theCourse.getLinks();
    String projName = theCourse.getProjectName();
    if (projName == null){
        projName = "Package";
}
%>
<html>
<script type="text/javascript" src="mtmcode.js"></script>
<script language="javascript">
<!--
// let lmsframe know when this has loaded


function NavigateItems(itemToLaunch)
{
    if(itemToLaunch !=""){
       top.window.LMSFrame.changeItem(itemToLaunch);
    }
}
//-->
</script>
<script type="text/javascript">
<!--
// Morten's JavaScript Tree Menu
// version 2.3.2-macfriendly, dated 2002-06-10
// http://www.treemenu.com/

// Copyright (c) 2001-2002, Morten Wang & contributors
// All rights reserved.

// This software is released under the BSD License which should accompany
// it in the file "COPYING".  If you do not have this file you can access
// the license through the WWW at http://www.treemenu.com/license.txt

// Nearly all user-configurable options are set to their default values.
// Have a look at the section "Setting options" in the installation guide
// for description of each option and their possible values.

MTMDefaultTarget = "text";

/******************************************************************************
* Default values of all user-configurable options.                            *
******************************************************************************/

var MTMLinkedJSURL , MTMLinkedSS = true, MTMSSHREF = "reload.css", MTMLinkedInitFunction, MTMDOCTYPE, MTMcontentType, MTMHeader, MTMFooter, MTMrightClickMessage, MTMDefaultTarget, MTMTimeOut = 5;
var MTMuseScrollbarCSS = true, MTMscrollbarBaseColor, MTMscrollbarFaceColor  = "#F4F7FF", MTMscrollbarHighlightColor, MTMscrollbarShadowColor, MTMscrollbar3dLightColor, MTMscrollbarArrowColor, MTMscrollbarTrackColor, MTMscrollbarDarkShadowColor;
var MTMUseCookies, MTMCookieName, MTMCookieDays, MTMTrackedCookieName;
var MTMCodeFrame = "code", MTMenuFrame = "menu", MTMTableWidth = "100%", MTMenuImageDirectory = "menu-images/";
var MTMUseToolTips = true, MTMEmulateWE = true, MTMAlwaysLinkIfWE = true, MTMSubsGetPlus = "Submenu", MTMSubsAutoClose;
var MTMBackground = "", MTMBGColor = "#F4F7FF", MTMTextColor = "#000000", MTMLinkColor = "#330099", MTMTrackColor = "#000000", MTMAhoverColor = "#990000", MTMSubExpandColor = "#666699", MTMSubClosedColor = "#666699", MTMSubTextColor = "#000000";
var MTMenuText = "<% out.print(projName); %>", MTMRootIcon = "book-open.gif", MTMRootColor = "#000000";
var MTMRootFont = MTMenuFont = "verdana";
var MTMRootCSSize = MTMenuCSSize = "70%";
var MTMRootFontSize = MTMenuFontSize = "0";

/******************************************************************************
* User-configurable list of icons.                                            *
******************************************************************************/

var MTMIconList = null;
MTMIconList = new IconList();
MTMIconList.addIcon(new MTMIcon("menu_link_external.gif", "http://", "pre"));
MTMIconList.addIcon(new MTMIcon("hiddenitemleaf.gif", "void(0)", "post"));

/******************************************************************************
* User-configurable menu.                                                     *
******************************************************************************/
// Main menu.
var menu = null;
menu = new MTMenu();
<%
/*
* Here we generate our menu system, based from the information found in the
* organizations section in the manifest
*/
// check that the navigation menu actually has some items in it...
if (manifestMenu != null){%>
<%String previousparent="menu";%>
<%Hashtable submenus = new Hashtable();%>
<%Hashtable submenusAdded = new Hashtable();%>
<%for(int i = 0; i < manifestMenu.length; i++) {%>
<%if ((submenus.containsKey(manifestMenu[i][2]))&&(previousparent.compareTo(manifestMenu[i][2])!=0)){%>
      <%String submenu = (String)submenus.get(manifestMenu[i][2]);%>
      <%=manifestMenu[i][2]%>.makeLastSubmenu(<%=submenu%>);
      <%submenusAdded.remove(manifestMenu[i][2]);%>
<%}%>
<%if ((!submenus.containsKey(manifestMenu[i][2]))&&(previousparent.compareTo(manifestMenu[i][2])!=0)){%>
      var <%=manifestMenu[i][2]%> = null;
      <%=manifestMenu[i][2]%> = new MTMenu();
      <%submenus.put(previousparent,manifestMenu[i][2]);%>
      <%submenusAdded.put(previousparent,manifestMenu[i][2]);%>
<%}%>
<%=manifestMenu[i][2]%>.addItem( "<%=manifestMenu[i][0]%>" , "<%=manifestMenu[i][1]%>" ,"code");
<%previousparent=manifestMenu[i][2];%>
<%}%>
<%Enumeration keys = submenusAdded.keys();%>
<%while(keys.hasMoreElements()) {%>
     <%String menuToAddTo = (String)keys.nextElement();%>
     <%String submenu = (String)submenusAdded.get(menuToAddTo);%>
     <%=menuToAddTo%>.makeLastSubmenu(<%=submenu%>);
<%}%>
<%submenus.clear();%>
<%submenusAdded.clear();%>
<%}%>
//-->
</script>
</head>
<body onload="MTMStartMenu(true);" bgcolor="#f0f0f0" text="#000000" link="blue" vlink="blue" alink="blue">
</body>
</html>
<%}else{%>
<html>
<head>
<title>Tree hidden</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body bgcolor="#F4F7FF" >
</body>
</html>
<%}%>
