package org.apache.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import org.apache.jasper.runtime.*;
import uk.ac.reload.scormplayer.server.sequence.*;
import uk.ac.reload.scormplayer.server.*;
import java.util.*;
import uk.ac.reload.scormplayer.server.manager.*;

public class LMSFrame_jsp extends HttpJspBase {


  private static java.util.Vector _jspx_includes;

  public java.util.List getIncludes() {
    return _jspx_includes;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    javax.servlet.jsp.PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html;charset=ISO-8859-1");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write("\r\n");

/**
  *  RELOAD SCORM Runtime Environment - A SCORM package runtime player
  *
  *  Copyright (c) 2003 Oleg Liber, Bill Olivier, Phillip Beauvoir, Paul Sharples
  *
  *  Permission is hereby granted, free of charge, to any person obtaining a copy
  *  of this software and associated documentation files (the "Software"), to deal
  *  in the Software without restriction, including without limitation the rights
  *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  *  copies of the Software, and to permit persons to whom the Software is
  *  furnished to do so, subject to the following conditions:
  *
  *  The above copyright notice and this permission notice shall be included in
  *  all copies or substantial portions of the Software.
  *
  *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  *
  *  Project Management Contact:
  *
  *  Oleg Liber
  *  Bolton Institute of Higher Education
  *  Deane Road
  *  Bolton BL3 5AB
  *  UK
  *
  *  e-mail:   o.liber@bolton.ac.uk
  *
  *
  *  Technical Contact:
  *
  *  Phillip Beauvoir
  *  e-mail:   p.beauvoir@bolton.ac.uk
  *
  *  Web:      http://www.reload.ac.uk
  *
  */

      out.write("\r\n");
      out.write("<html>\r\n");
      out.write("<script>\r\n");
      out.write("<!--\r\nvar debug = \"false\";\r\nvar looseChecking =\"false\";\r\n//-->\r\n");
      out.write("</script>\r\n");

// 2 globals to hold previous/next pages
String prevItem = null;
String nextItem = null;
// initially load in model for this sco from server model
String scoID = (String)request.getParameter("scoID");
ScormManager theCourse = ScormLaunch.PackageToPlay;
// used to signal if item is a sco
boolean loadModelFlag = false;
// used to signal if we need to load in a sco or asset into the content frame 'text'
boolean loadPageFlag = false;
// used to flag if any prequisites were found
boolean prereqs = false;

// next check to see if this is an sco...
if (scoID !="" && scoID != null){
  theCourse._sequence.setCurrentSco(scoID);
  ReloadItemSequence item = theCourse._sequence.getItem(scoID);
  if (item != null){
     loadPageFlag = true;
     // check for prerequisites...
     prereqs = theCourse._sequence.checkItemsPrerequisites();
     if (prereqs){
        if (item.isItemSco()){
           loadModelFlag = true;
           item.loadInModel();
           //theCourse._sequence.getItem(scoID).loadInModel();
           //String[][] scoElements = theCourse._sequence.getItem(scoID).getScoModel();
           String[][] scoElements = item.getScoModel();
           out.print("<script language=javascript>\n");
           out.print("<!--\n");
           out.print("function loadInModel(){\n");

           for (int i=0; i < scoElements.length; i++){
             out.print("      loadDataIntoModel(\""+ scoElements[i][0] +"\",\""+ scoElements[i][1] +"\");\n");
           }
           out.print("}\n");
           out.print("\n//-->\n");
           out.print("</script>");
        }
        else{
           // this item is an asset - set it to completed
           out.print("<script language=javascript>\n");
           out.print("<!--\n");
           out.print("top.window.LMSUpdate.docompletedAsset(\""+scoID+"\");");
           out.print("\n//-->\n");
           out.print("</script>");
        }
     }
     else{
        // prerequisite check must have returned false...
           loadPageFlag = false;
           out.print("<script language=javascript>\n");
           out.print("<!--\n");
           out.print("top.window.text.location.href=\"prerequisites.htm\"");
           out.print("\n//-->\n");
           out.print("</script>");
     }
    // figure out what the next and previous items are
    String seq = item.getSequence();
    int theSeq = Integer.parseInt(seq);
    int next = theSeq + 1;
    int prev = theSeq - 1;
    if (!theCourse._sequence.isFirstItem(scoID)){
        // get the previous item and store
        prevItem = theCourse._sequence.findItemFromIndex(prev+"");
    }
    if (!theCourse._sequence.isLastItem(scoID)){
        // get the previous item and store
        nextItem = theCourse._sequence.findItemFromIndex(next+"");
    }
  }
}
else{

  // no sco selected, so find the next one in the course...
  String itemToLaunch = theCourse._sequence.findFirstItemToLaunch();
  if (itemToLaunch != null){
     out.print("<script language=javascript>\n");
     out.print("<!--\n");
     if (itemToLaunch.equals("completed")){
         out.print("top.window.frames.text.location.href=\"course_completed.htm\"");
     }else{
         out.print("top.window.frames.LMSFrame.location.href=\"LMSFrame.jsp?scoID="+itemToLaunch+"\"");
     }
     out.print("\n//-->\n");
     out.print("</script>");
  }
}

      out.write("\r\n\r\n");
      out.write("<script>\r\n");
      out.write("<!--\r\nfunction gotoErrorPage(){\r\n   top.window.location.href = \"scope_error.htm\";\r\n}\r\n\r\n\r\n/*\r\n* -----------------------------------------------------------------------------------------------\r\n*  Convenience Methods needed for SCO communication\r\n* -----------------------------------------------------------------------------------------------\r\n*/\r\n\r\n\r\n/*\r\n* Function to initially load the server model CMI elements into the javascript\r\n* model, when this page first loads.\r\n*/\r\nfunction loadDataIntoModel(element, value){\r\n  if (element != \"cmi.interactions._count\" && element != \"cmi.interactions._count\"){\r\n        if (element.indexOf(\"cmi.objectives\") != -1){\r\n             dealWithSettingObjectives(element, value);\r\n        }\r\n        else if (element.indexOf(\"cmi.interactions\") != -1){\r\n             dealWithSettingInteractions(element, value);\r\n        }\r\n        else{\r\n           var result = eval (\"API.\"+element);\r\n           if (result != null){\r\n                result.cmivalue = value;\r\n           }\r\n        }\r\n");
      out.write("  }\r\n}\r\n\r\n\r\n/*\r\n* Function to call javascript in hidden frame \"LMSUpdate\", which gets the\r\n* current state of the cmi datamodel and updates the server model\r\n*/\r\nfunction updateServer(){\r\n    top.window.LMSUpdate.updateServerCMIModel();\r\n}\r\n\r\n\r\n\r\n/*\r\n*  Object ServerScoSettings()\r\n*  Used to store server specific settings and error codes etc..\r\n*  Is accessed as an object inside this implementation of the API object.\r\n*/\r\nfunction ServerScoSettings(){\r\n\tthis.isInitialized = \"false\";\r\n\tthis.lastError = \"0\";\r\n        this.checkDataTypeAndVocab = scoCheckDataTypeAndVocab;\r\n}\r\n\r\n\r\n/*\r\n* A CMIComponent holds properties for each CMI element in the model.\r\n* Here we keep the element name, it current value, its read/write status\r\n* and finally it CMI datatype\r\n*/\r\nfunction CMIComponent(thename, thevalue, readstatus, datatype){\r\n\tthis.cminame=thename;\r\n\tthis.cmivalue=thevalue;\r\n\tthis.cmireadStatus=readstatus;\r\n        this.cmidatatype=datatype;\r\n}\r\n\r\n\r\n/*\r\n* Top level object to hold complete CMI data model and API methods\r\n");
      out.write("*/\r\nfunction GenericAPIAdaptor(){\r\n\tthis.cmi = new CMIModel;\r\n\tthis.LMSInitialize = LMSInitializeMethod;\r\n\tthis.LMSGetValue = LMSGetValueMethod;\r\n\tthis.LMSSetValue = LMSSetValueMethod;\r\n\tthis.LMSCommit = LMSCommitMethod;\r\n\tthis.LMSFinish = LMSFinishMethod;\r\n\tthis.LMSGetLastError = LMSGetLastErrorMethod;\r\n\tthis.LMSGetErrorString = LMSGetErrorStringMethod;\r\n\tthis.LMSGetDiagnostic = LMSGetDiagnosticMethod;\r\n\tthis.ServerSco = new ServerScoSettings;\r\n}\r\n\r\n\r\n\r\n/*\r\n* ---------------------------------------------------------------------------------------------\r\n*\tAPI Javascript Functions\r\n* ---------------------------------------------------------------------------------------------\r\n*/\r\n\r\n/*\r\n* LMSInitialize. Initialize this sco (if it is one)\r\n*/\r\nfunction LMSInitializeMethod(parameter){\r\n    // check that this has been called with an empty string...\r\n\tif (parameter != \"\"){\r\n\t\tthis.ServerSco.lastError = \"201\"\r\n\t\treturn \"false\";\r\n\t}\r\n    // check that we are not already initialized...\r\n    if(this.ServerSco.isInitialized == \"false\"){\r\n");
      out.write("\t\tthis.ServerSco.isInitialized = \"true\";\r\n\t\tthis.ServerSco.lastError = \"0\"\r\n\t\treturn \"true\";\r\n\t}\r\n\telse{\r\n\t\tthis.ServerSco.lastError = \"101\"\r\n\t\treturn \"false\";\r\n\t}\r\n}\r\n\r\n\r\n\r\n/*\r\n* LMSFinish. Finish this sco session.\r\n*/\r\nfunction LMSFinishMethod(parameter){\r\n//alert(\"lms finish called\");\r\n    // check that this has been called with an empty string...\r\n\tif (parameter != \"\"){\r\n\t\tthis.ServerSco.lastError = \"201\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n    // make sure that the server is initialized...\r\n\tif (this.ServerSco.isInitialized==\"true\"){\r\n        // call LMSCommit in case the sco forgot to do so...\r\n\t\tanswer = this.LMSCommit(\"\");\r\n\t\tif (answer != \"false\"){\r\n\t\t\tthis.ServerSco.isInitialized = \"false\";\r\n\t\t\tthis.ServerSco.lastError = \"0\";\r\n\t\t\treturn \"true\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// LMSCommit failed at some point so...\r\n            // no need to set the error code as LMSCommit should have done this\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n    }\r\n    else{\r\n\t\t// not initialized\r\n\t\tthis.ServerSco.lastError = \"301\";\r\n\t\treturn \"false\";\r\n\t}\r\n}\r\n\r\n");
      out.write("\r\n\r\n/*\r\n* LMSCommit.  Method to update/persist any changed items in the CMI datamodel\r\n*/\r\nfunction LMSCommitMethod(parameter){\r\n    // check that this has been called with an empty string...\r\n\tif (parameter!=\"\"){\r\n\t\tthis.ServerSco.lastError = \"201\"\r\n\t\treturn \"false\";\r\n\t}\r\n\tif (this.ServerSco.isInitialized == \"true\"){\r\n\t\t\tupdateServer();\r\n\t\t\tthis.ServerSco.lastError = \"0\";\r\n\t\t\treturn \"true\";\r\n\t}\r\n\telse{\r\n\t\t// not initialized\r\n\t\tthis.ServerSco.lastError = \"301\";\r\n\t\treturn \"false\";\r\n\t}\r\n}\r\n\r\n\r\n\r\nfunction dealWithGettingObjectives(element){\r\n\t// RETURN _CHILDREN\r\n\tif (element == \"cmi.objectives._children\"){\r\n\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\treturn API.cmi.objectives._children.cmivalue;\r\n\t}\r\n\r\n\t// RETURN _COUNT\r\n\tif (element == \"cmi.objectives._count\"){\r\n\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\treturn API.cmi.objectives._count.cmivalue;\r\n\t}\r\n\r\n\t// ELSE CHECK THAT THE ELEMENT IS VALID AND HAS AT LEAST 3 PARAMS\r\n\tvar cmiArray = element.split(\".\");\r\n\tif (cmiArray.length ");
      out.write("< 3){\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"\";\r\n\t}\r\n\r\n\tvar theCount = API.cmi.objectives._count.cmivalue;\r\n\r\n\t// IF 3RD ARG IS NOT A NUMBER THEN THROW ERROR\r\n\t// need to check cmiArray[2] to see if its a number\r\n\tif (isNaN(cmiArray[2])){\r\n\t\tAPI.ServerSco.lastError = \"401\";\r\n\t\treturn \"\";\r\n\t}\r\n\r\n\t// IF ITS A NUMBER MAKE SURE ITS IN THE ARRAY BOUNDS\r\n\tif(cmiArray[2] >= theCount){\r\n\t\t// call to array is out of bounds\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"\";\r\n\t}\r\n\telse{\t// WEVE GOT TO THE POINT OF VALIDATING cmi.objective.n\r\n\t\t// does this element exist in the objectives array? - sanity check...\r\n\t\tvar mystr = \"API.\"+cmiArray[0] + \".\" + cmiArray[1] + \".objArray(\" + cmiArray[2] + \");\";\r\n\t\tans = eval(mystr);\r\n\t\t//if it doesn't exist\r\n\t\tif (ans == null){\r\n\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\treturn \"\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// we need to see if the call is asking for a valid element under cmi.objectives.n\r\n\t\t\t// we can trust the element parameter now to call the following...\r\n\t\t\tsubelementstr = \"ans\";\r\n");
      out.write("\t\t\tfor (i=3;i");
      out.write("<cmiArray.length;i++){\r\n\t\t\t\tsubelementstr = subelementstr + \".\" + cmiArray[i];\r\n\t\t\t}\r\n\r\n\t\t\tvar objTest = eval(subelementstr);\r\n\t\t\t//alert(\"objTest: \"+objTest);\r\n\t\t\tif (objTest == null){\r\n\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\treturn \"false\";\r\n\t\t\t}\r\n\r\n\t\t\tsubelementstr = subelementstr + \".cmivalue;\";\r\n\t\t\tres = eval(subelementstr);\r\n\t\t\tif (res == null){\r\n\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\treturn \"\";\r\n\t\t\t}\r\n\t\t\telse{\r\n\t\t\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\t\t\treturn res;\r\n\t\t\t}\r\n\t\t}\r\n\t}\r\n}\r\n\r\n\r\nfunction dealWithGettingInteractions(element){\r\n\t// RETURN _CHILDREN\r\n\tif (element == \"cmi.interactions._children\"){\r\n\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\treturn API.cmi.interactions._children.cmivalue;\r\n\t}\r\n\r\n\t// RETURN _COUNT\r\n\tif (element == \"cmi.interactions._count\"){\r\n\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\treturn API.cmi.interactions._count.cmivalue;\r\n\t}\r\n\r\n\t// ELSE CHECK THAT THE ELEMENT IS VALID AND HAS AT LEAST 3 PARAMS, DOESNT HAVE\r\n\t// MORE THAN 6 PARAMS  - IF SO, ITS ILLEGAL\r\n\tvar cmiArray = element.split(\".\");\r\n");
      out.write("\tif (cmiArray.length ");
      out.write("< 3 || cmiArray.length > 6){\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"\";\r\n\t}\r\n\r\n\tvar theCount = API.cmi.interactions._count.cmivalue;\r\n\r\n\t// IF 3RD ARG IS NOT A NUMBER THEN THROW ERROR\r\n\t// need to check cmiArray[2] to see if its a number\r\n\tif (isNaN(cmiArray[2])){\r\n\t\tAPI.ServerSco.lastError = \"401\";\r\n\t\treturn \"\";\r\n\t}\r\n\r\n\t// IF ITS A NUMBER MAKE SURE ITS IN THE ARRAY BOUNDS\r\n\tif(cmiArray[2] >= theCount){\r\n\t\t// call to array is out of bounds\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"\";\r\n\t}\r\n\telse{\t// WEVE GOT TO THE POINT OF VALIDATING cmi.interactions.n\r\n\t\t// does this element exist in the interactions array? - sanity check...\r\n\t\t//\r\n\t\t// We are checking that 'cmi.interactions.n' exists\r\n\t\tvar mystr = \"API.\"+cmiArray[0] + \".\" + cmiArray[1] + \".intArray(\" + cmiArray[2] + \")\";\r\n\t\tans = eval(mystr);\r\n\t\t//if it doesn't exist\r\n\t\tif (ans==null){\r\n\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\treturn \"\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// if theres 4 bits to the element path then try to see if object exists\r\n\t\t\tif (cmiArray.length == 4){\r\n");
      out.write("\t\t\t\tstrleaf = \"ans.\"+ cmiArray[3] + \";\";\r\n\t\t\t\tvar doesLeafExist = eval (strleaf);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n\t\t\t\t\t// NEXT CHECK THAT THIS ELEMENT IS NOT WRITEONLY\r\n\t\t\t\t\tstrleafstatus = mystr + \".\"+ cmiArray[3] + \".cmireadStatus;\";\r\n\t\t\t\t\tvar leafstatus = eval(strleafstatus);\r\n\t\t\t\t\tif (leafstatus == \"writeonly\"){\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"404\";\r\n\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t}\r\n\r\n\t\t\t\t\t// WE CAN NOW TRY TO GET THE FULL OBJECT REFERENCE\r\n\t\t\t\t\tvar strleafval = mystr + \".\"+ cmiArray[3] + \".cmivalue;\";\r\n\t\t\t\t\tvar leafVal = eval(strleafval);\r\n\t\t\t\t\tif (leafVal == null){\r\n\t\t\t\t\t\t// IT FAILED AT THE FINAL HURDLE...\r\n\t\t\t\t\t\t//alert(\"cvalue:\"+leafVal);\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\telse{\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t//alert(\"value:\"+leafVal);\r\n\t\t\t\t\t\treturn leafVal;\r\n\t\t\t\t\t}\r\n\r\n\t\t\t\t}\r\n\t\t\t}\r\n\t\t\t// if theres 5 bits to the element path then try to see if object exists\r\n\t\t\tif (cmiArray.length == 5){\r\n");
      out.write("\t\t\t\t// check object exists\r\n\t\t\t\tstrbranch = \"ans.\"+ cmiArray[3] + \";\";\r\n\t\t\t\tvar doesLeafExist = eval (strbranch);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// check final object exists in the array list...\r\n\t\t\t\tnextstrbranch = \"ans.\"+ cmiArray[3] + \".\" + cmiArray[4] + \";\";\r\n\t\t\t\tvar doesLeafExist = eval (nextstrbranch);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// check for write only\r\n\t\t\t\tstrread = \"ans.\"+ cmiArray[3] + \".\" + cmiArray[4] + \".cmireadStatus;\";\r\n\t\t\t\tvar isWriteOnly = eval (strread);\r\n\t\t\t\tif (isWriteOnly == \"writeonly\"){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"404\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// see if value exists\r\n\t\t\t\tstrleaf = \"ans.\"+ cmiArray[3] + \".\" + cmiArray[4] + \".cmivalue;\";\r\n\t\t\t\tvar doesLeafExist = eval (strleaf);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n\t\t\t\t\t//alert(\"found:\"+doesLeafExist);\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"0\";\r\n");
      out.write("\t\t\t\t\treturn doesLeafExist;\r\n\t\t\t\t}\r\n\r\n\t\t\t}\r\n\t\t\t// if theres 6 bits to the element path then try to see if object exists\r\n\t\t\tif (cmiArray.length == 6){\r\n\t\t\t\t// check object exists\r\n\t\t\t\tstrbranch = \"ans.\"+ cmiArray[3];\r\n\t\t\t\tvar doesBranchExist = eval (strbranch);\r\n\t\t\t\tif (doesBranchExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\t\t\t\t// The fifth argument should be an array reference, so do some checking...\r\n\r\n\t\t\t\t// IF 5TH ARG IS NOT A NUMBER THEN THROW ERROR\r\n\t\t\t\t// need to check cmiArray[4] to see if its a number\r\n\t\t\t\tif (isNaN(cmiArray[4])){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"401\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// check to see if this element has a _count\r\n\t\t\t\t// If it hasn't we'll have to throw an error here\r\n\t\t\t\t// because we need the correct array index for array #2...\r\n\t\t\t\tvar theCount = \"ans.\" + cmiArray[3] + \"._count.cmivalue;\";\r\n\t\t\t\tvar hasCount = eval(theCount);\r\n\t\t\t\t// CANT FIND _COUNT FOR THIS ELEMENT, SO THROW AN ERROR...\r\n\t\t\t\tif (hasCount == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n");
      out.write("\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\t\t\t\t// next need to check to see if array ref is in array bounds\r\n\t\t\t\tif(cmiArray[4] >= hasCount || cmiArray[4] ");
      out.write("< 0){\r\n\t\t\t\t\t// call to array is out of bounds\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\t\t\t\t// make sure that array index 4 is either 'objectives' or 'correct_responses'\r\n\t\t\t\tif (cmiArray[3] == \"objectives\"){\r\n\t\t\t\t\t// next check that there is an object here at this array index...\r\n\t\t\t\t\tvar arrayIndex2Check = eval(\"ans.\" + cmiArray[3] + \".objectivesInteractionArray(\" + cmiArray[4] + \")\");\r\n\t\t\t\t\t// check for null\r\n\t\t\t\t\tif (arrayIndex2Check == null){\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\telse{\r\n\t\t\t\t\t\t// next check that the last element is valid...\r\n\t\t\t\t\t\tfinalObjectCheck = eval (\"arrayIndex2Check.\" + cmiArray[5]);\r\n\t\t\t\t\t\tif (finalObjectCheck == null){\r\n\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t\telse{\r\n\t\t\t\t\t\t\t// call must be to a valid element in the model so...\r\n\t\t\t\t\t\t\t// check it for writeonly...\r\n\t\t\t\t\t\t\tisWriteonly = eval (\"finalObjectCheck.cmireadStatus\");\r\n\t\t\t\t\t\t\tif (isWriteonly == \"writeonly\"){\r\n\t\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"404\";\r\n");
      out.write("\t\t\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\telse{\r\n\t\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t\t\treturn eval (\"finalObjectCheck.cmivalue\");\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n\t\t\t\telse if (cmiArray[3] == \"correct_responses\"){\r\n\t\t\t\t\t// next check that there is an object here at this array index...\r\n\t\t\t\t\tvar arrayIndex2Check = eval(\"ans.\" + cmiArray[3] + \".correctResponsesInteractionArray(\" + cmiArray[4] + \")\");\r\n\t\t\t\t\t// check for null\r\n\t\t\t\t\tif (arrayIndex2Check == null){\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\telse{\r\n\t\t\t\t\t\t// next check that the last element is valid...\r\n\t\t\t\t\t\tfinalObjectCheck = eval (\"arrayIndex2Check.\" + cmiArray[5]);\r\n\t\t\t\t\t\tif (finalObjectCheck == null){\r\n\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t\telse{\r\n\t\t\t\t\t\t\t// call must be to a valid element in the model so...\r\n\t\t\t\t\t\t\t// check it for writeonly...\r\n\t\t\t\t\t\t\tisWriteonly = eval (\"finalObjectCheck.cmireadStatus\");\r\n\t\t\t\t\t\t\tif (isWriteonly == \"writeonly\"){\r\n\t\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"404\";\r\n");
      out.write("\t\t\t\t\t\t\t\treturn \"\";\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\telse{\r\n\t\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t\t\treturn eval (\"finalObjectCheck.cmivalue\");\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n\t\t\t\telse {\r\n\t\t\t\t\t// throw an error becuase 4th arg was not either\r\n\t\t\t\t\t// objectives or correct_responses\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"\";\r\n\t\t\t\t}\r\n\t\t\t}\r\n\t\t}\r\n\t}\r\n}\r\n\r\n\r\n\r\n\r\nfunction dealWithSettingObjectives(element, value){\r\n\t//  _CHILDREN ARE READONLY\r\n\tif (element == \"cmi.objectives._children\"){\r\n\t\tAPI.ServerSco.lastError = \"402\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\t//  _COUNT IS READ ONLY\r\n\tif (element == \"cmi.objectives._count\"){\r\n\t\tAPI.ServerSco.lastError = \"402\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\t// ELSE CHECK THAT THE ELEMENT IS VALID AND HAS AT LEAST 3 PARAMS\r\n\tvar cmiArray = element.split(\".\");\r\n\tif (cmiArray.length ");
      out.write("< 3){\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\t// IF 3RD ARG IS NOT A NUMBER THEN THROW ERROR\r\n\t// need to check cmiArray[2] to see if its a number\r\n\tif (isNaN(cmiArray[2])){\r\n\t\tAPI.ServerSco.lastError = \"401\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\r\n\tvar theCount = API.cmi.objectives._count.cmivalue;\r\n\r\n\t// IF ITS A NUMBER MAKE SURE ITS IN THE ARRAY BOUNDS\r\n\tif(cmiArray[2] > theCount || cmiArray[2] ");
      out.write("< 0){\r\n\t\t// call to array is out of bounds\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"false\";\r\n\t}\r\n\telse if(cmiArray[2] == theCount || cmiArray[2]  ");
      out.write("< theCount){\r\n\r\n\t\t//create a new one\r\n\t\tvar existingObjectiveHandle = API.cmi.objectives.objArray(cmiArray[2]);\r\n\t\tif (existingObjectiveHandle == null){\r\n\t\t\tAPI.ServerSco.lastError = \"101\";\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// we need to see if the call is asking for a valid element under cmi.objectives.n\r\n\t\t\t// we can trust the element parameter now to call the following...\r\n\t\t\tsubelementstr = \"existingObjectiveHandle\";\r\n\t\t\tfor (i=3;i");
      out.write("<cmiArray.length;i++){\r\n\t\t\t\tsubelementstr = subelementstr + \".\" + cmiArray[i];\r\n\t\t\t}\r\n\r\n\t\t\tvar objTest = eval(subelementstr);\r\n\t\t\t//alert(\"objTest: \"+objTest);\r\n\t\t\tif (objTest == null){\r\n\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\treturn \"false\";\r\n\r\n\t\t\t}\r\n\r\n\t\t\tvar subelementstrWithoutLeaf = subelementstr;\r\n\t\t\tsubelementstr = subelementstr + \".cmireadStatus;\";\r\n\t\t\tres = eval(subelementstr);\r\n\t\t\tif (res == null){\r\n\t\t\t\tAPI.ServerSco.lastError = \"101\";\r\n\t\t\t\treturn \"false\";\r\n\t\t\t}\r\n\t\t\telse{\r\n\t\t\t\tif (res == \"readonly\"){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"403\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n\r\n                    // check the datatype and vocabulary...\r\n                    var datatype = objTest.cmidatatype;\r\n                    res = API.ServerSco.checkDataTypeAndVocab(element, value, datatype);\r\n\r\n                    if (res == \"true\"){\r\n                        // correct datatype...\r\n  \t\t\t            // WE CAN NOW TRY TO SET THE FULL OBJECT REFERENCE\r\n\t\t\t\t\t    var strleafval = \"objTest.cmivalue =\\\"\" + value + \"\\\";\";\r\n");
      out.write("\t\t\t\t\t    var leafVal = eval(strleafval);\r\n\t\t\t\t\t    if (leafVal == null){\r\n\t\t\t\t\t\t    // IT FAILED AT THE FINAL HURDLE...\r\n\t\t\t\t\t\t    API.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t    return \"false\";\r\n\t\t\t\t\t   }\r\n\t\t\t\t\t   else{\r\n\t\t\t\t\t\t    API.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t    return \"true\";\r\n\t\t\t\t\t   }\r\n                   }\r\n                   else{\r\n                       // incorrect data type...\r\n\t\t\t           API.ServerSco.lastError = \"405\";\r\n                       return \"false\";\r\n                   }\r\n\r\n\t\t\t\t}\r\n\t\t\t}\r\n\t\t}\r\n\t}\r\n}\r\n\r\n\r\n\r\nfunction dealWithSettingInteractions(element, value){\r\n\t//  _CHILDREN ARE READONLY\r\n\tif (element == \"cmi.interactions._children\"){\r\n\t\tAPI.ServerSco.lastError = \"402\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\t//  _COUNT IS READ ONLY\r\n\tif (element == \"cmi.interactions._count\"){\r\n\t\tAPI.ServerSco.lastError = \"402\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\t// ELSE CHECK THAT THE ELEMENT IS VALID AND HAS AT LEAST 3 PARAMS, DOESNT HAVE\r\n\t// MORE THAN 6 PARAMS  - ALL ILLEGAL\r\n\tvar cmiArray = element.split(\".\");\r\n\tif (cmiArray.length ");
      out.write("< 3 || cmiArray.length > 6){\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\tvar theCount = API.cmi.interactions._count.cmivalue;\r\n\r\n\t// IF 3RD ARG IS NOT A NUMBER THEN THROW ERROR\r\n\t// need to check cmiArray[2] to see if its a number\r\n\tif (isNaN(cmiArray[2])){\r\n\t\tAPI.ServerSco.lastError = \"401\";\r\n\t\treturn \"false\";\r\n\t}\r\n\r\n\tvar theCount = API.cmi.interactions._count.cmivalue;\r\n\r\n\t// IF ITS A NUMBER MAKE SURE ITS IN THE ARRAY BOUNDS\r\n\tif(cmiArray[2] > theCount || cmiArray[2] ");
      out.write("< 0){\r\n\t\t// call to array is out of bounds\r\n\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\treturn \"false\";\r\n\t}\r\n\telse if(cmiArray[2] ");
      out.write("<= theCount){\r\n\r\n\t\t//create a new one or get existing object\r\n\t\tvar existingObjectiveHandle = API.cmi.interactions.intArray(cmiArray[2]);\r\n\t\tif (existingObjectiveHandle == null){\r\n\t\t\tAPI.ServerSco.lastError = \"101\";\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// we now have a reference to cmi.interactions.n\r\n\t\t\t// if theres 4 bits to the element path then try to see if object exists\r\n\r\n\t\t\tif (cmiArray.length == 4){\r\n\t\t\t\tstrleaf = \"existingObjectiveHandle.\" + cmiArray[3];\r\n\t\t\t\tvar doesLeafExist = eval (strleaf);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n\r\n\t\t\t\t\t// NEXT CHECK THAT THIS ELEMENT IS NOT READONLY\r\n\t\t\t\t\tstrleafstatus = \"doesLeafExist.cmireadStatus\";\r\n\t\t\t\t\tvar leafstatus = eval(strleafstatus);\r\n\t\t\t\t\tif (leafstatus == \"readonly\"){\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"403\";\r\n\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t}\r\n\r\n                    // check the datatype and vocabulary...\r\n                    var datatype = doesLeafExist.cmidatatype;\r\n                    res = API.ServerSco.checkDataTypeAndVocab(element, value, datatype);\r\n");
      out.write("                    if (res == \"true\"){\r\n                        // correct datatype...\r\n  \t\t\t            // WE CAN NOW TRY TO SET THE FULL OBJECT REFERENCE\r\n\t\t\t\t\t    var strleafval = \"doesLeafExist.cmivalue =\\\"\" + value + \"\\\";\";\r\n\t\t\t\t\t    var leafVal = eval(strleafval);\r\n\t\t\t\t\t    if (leafVal == null){\r\n\t\t\t\t\t\t    // IT FAILED AT THE FINAL HURDLE...\r\n\t\t\t\t\t\t    API.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t    return \"false\";\r\n\t\t\t\t\t   }\r\n\t\t\t\t\t   else{\r\n\t\t\t\t\t\t    API.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t    return \"true\";\r\n\t\t\t\t\t   }\r\n                   }\r\n                   else{\r\n                       // incorrect data type...\r\n\t\t\t           API.ServerSco.lastError = \"405\";\r\n                       return \"false\";\r\n                   }\r\n\t\t\t\t}\r\n\t\t\t}\r\n\t\t\tif (cmiArray.length == 5){\r\n\t\t\t\t// check object exists\r\n\t\t\t\tstrbranch = \"existingObjectiveHandle.\"+ cmiArray[3] + \";\";\r\n\t\t\t\tvar doesLeafExist = eval (strbranch);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// check final object exists in the array list...\r\n");
      out.write("\t\t\t\tnextstrbranch = \"existingObjectiveHandle.\"+ cmiArray[3] + \".\" + cmiArray[4] + \";\";\r\n\t\t\t\tvar doesLeafExist = eval (nextstrbranch);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// check for write only\r\n\t\t\t\tstrread = \"existingObjectiveHandle.\"+ cmiArray[3] + \".\" + cmiArray[4] + \".cmireadStatus;\";\r\n\t\t\t\tvar isWriteOnly = eval (strread);\r\n\t\t\t\tif (isWriteOnly == \"readonly\"){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"403\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// see if value exists\r\n\t\t\t\tstrleaf = \"existingObjectiveHandle.\"+ cmiArray[3] + \".\" + cmiArray[4] + \".cmivalue;\";\r\n\t\t\t\tvar doesLeafExist = eval (strleaf);\r\n\t\t\t\tif (doesLeafExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n                    // check the datatype and vocabulary...\r\n                    var datatype = doesLeafExist.cmidatatype;\r\n                    res = API.ServerSco.checkDataTypeAndVocab(element, value, datatype);\r\n                    if (res == \"true\"){\r\n");
      out.write("                        // correct datatype...\r\n  \t\t\t            // WE CAN NOW TRY TO SET THE FULL OBJECT REFERENCE\r\n\t\t\t\t\t    var strleafval = \"doesLeafExist.cmivalue =\\\"\" + value + \"\\\";\";\r\n\t\t\t\t\t    var leafVal = eval(strleafval);\r\n\t\t\t\t\t    if (leafVal == null){\r\n\t\t\t\t\t\t    // IT FAILED AT THE FINAL HURDLE...\r\n\t\t\t\t\t\t    API.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t    return \"false\";\r\n\t\t\t\t\t    }\r\n\t\t\t\t\t    else{\r\n\t\t\t\t\t\t    API.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t    return \"true\";\r\n\t\t\t\t\t    }\r\n                    }\r\n                    else{\r\n                       // incorrect data type...\r\n\t\t\t           API.ServerSco.lastError = \"405\";\r\n                       return \"false\";\r\n                    }\r\n\t\t\t\t}\r\n\t\t\t}\r\n\t\t\tif (cmiArray.length == 6){\r\n\t\t\t\t// check object exists\r\n\t\t\t\tstrbranch = \"existingObjectiveHandle.\"+ cmiArray[3];\r\n\t\t\t\tvar doesBranchExist = eval (strbranch);\r\n\t\t\t\tif (doesBranchExist == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\t\t\t\t// The fifth argument should be an array reference, so do some checking...\r\n");
      out.write("\r\n\t\t\t\t// IF 5TH ARG IS NOT A NUMBER THEN THROW ERROR\r\n\t\t\t\t// need to check cmiArray[4] to see if its a number\r\n\t\t\t\tif (isNaN(cmiArray[4])){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"401\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// check to see if this element has a _count\r\n\t\t\t\t// If it hasn't we'll have to throw an error here\r\n\t\t\t\t// because we need the correct array index for array #2...\r\n\t\t\t\tvar theCount = \"existingObjectiveHandle.\" + cmiArray[3] + \"._count.cmivalue;\";\r\n\t\t\t\tvar hasCount = eval(theCount);\r\n\t\t\t\t// CANT FIND _COUNT FOR THIS ELEMENT, SO THROW AN ERROR...\r\n\t\t\t\tif (hasCount == null){\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\t\t\t\t// next need to check to see if array ref is in array bounds\r\n\t\t\t\tif(cmiArray[4] > hasCount || cmiArray[4] ");
      out.write("< 0){\r\n\t\t\t\t\t// call to array is out of bounds\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\r\n\t\t\t\t// make sure that array index 4 is either 'objectives' or 'correct_responses'\r\n\t\t\t\tif (cmiArray[3] == \"objectives\"){\r\n\t\t\t\t\t// next check that there is an object here at this array index...\r\n\t\t\t\t\tvar arrayIndex2Check = eval(\"existingObjectiveHandle.\" + cmiArray[3] + \".objectivesInteractionArray(\" + cmiArray[4] + \")\");\r\n\t\t\t\t\t// check for null\r\n\t\t\t\t\tif (arrayIndex2Check == null){\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\telse{\r\n\t\t\t\t\t\t// next check that the last element is valid...\r\n\t\t\t\t\t\tfinalObjectCheck = eval (\"arrayIndex2Check.\" + cmiArray[5]);\r\n\t\t\t\t\t\tif (finalObjectCheck == null){\r\n\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t\telse{\r\n\t\t\t\t\t\t\t// call must be to a valid element in the model so...\r\n\t\t\t\t\t\t\t// check it for readonly...\r\n\t\t\t\t\t\t\tisWriteonly = eval (\"finalObjectCheck.cmireadStatus\");\r\n\t\t\t\t\t\t\tif (isWriteonly == \"readonly\"){\r\n");
      out.write("\t\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"403\";\r\n\t\t\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\telse{\r\n\r\n                                // check the datatype and vocabulary...\r\n                                var datatype = finalObjectCheck.cmidatatype;\r\n                                res = API.ServerSco.checkDataTypeAndVocab(element, value, datatype);\r\n                                if (res == \"true\"){\r\n                                    // correct datatype...\r\n  \t\t\t                        // WE CAN NOW TRY TO SET THE FULL OBJECT REFERENCE\r\n                                    var strleafval = \"finalObjectCheck.cmivalue =\\\"\" + value + \"\\\";\";\r\n\t\t\t\t\t                var leafVal = eval(strleafval);\r\n\t\t\t\t\t                if (leafVal == null){\r\n\t\t\t\t\t\t                // IT FAILED AT THE FINAL HURDLE...\r\n\t\t\t\t\t\t                API.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t                return \"false\";\r\n                                    }\r\n\t\t\t\t\t                else{\r\n\t\t\t\t\t\t               API.ServerSco.lastError = \"0\";\r\n\t\t\t\t\t\t               return \"true\";\r\n");
      out.write("\t\t\t\t\t                }\r\n                               }\r\n                               else{\r\n                                   // incorrect data type...\r\n\t\t\t                       API.ServerSco.lastError = \"405\";\r\n                                   return \"false\";\r\n                               }\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n\t\t\t\telse if (cmiArray[3] == \"correct_responses\"){\r\n\t\t\t\t\t// next check that there is an object here at this array index...\r\n\t\t\t\t\tvar arrayIndex2Check = eval(\"existingObjectiveHandle.\" + cmiArray[3] + \".correctResponsesInteractionArray(\" + cmiArray[4] + \")\");\r\n\t\t\t\t\t// check for null\r\n\t\t\t\t\tif (arrayIndex2Check == null){\r\n\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\telse{\r\n\t\t\t\t\t\t// next check that the last element is valid...\r\n\t\t\t\t\t\tfinalObjectCheck = eval (\"arrayIndex2Check.\" + cmiArray[5]);\r\n\t\t\t\t\t\tif (finalObjectCheck == null){\r\n\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t\telse{\r\n\t\t\t\t\t\t\t// call must be to a valid element in the model so...\r\n");
      out.write("\t\t\t\t\t\t\t// check it for readonly...\r\n\t\t\t\t\t\t\tisWriteonly = eval (\"finalObjectCheck.cmireadStatus\");\r\n\t\t\t\t\t\t\tif (isWriteonly == \"readonly\"){\r\n\t\t\t\t\t\t\t\tAPI.ServerSco.lastError = \"403\";\r\n\t\t\t\t\t\t\t\treturn \"false\";\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\telse{\r\n                                                               // check the datatype and vocabulary...\r\n                                                               var datatype = finalObjectCheck.cmidatatype;\r\n                                                               res = API.ServerSco.checkDataTypeAndVocab(element, value, datatype);\r\n                                                               if (res == \"true\"){\r\n                                                                   // correct datatype...\r\n  \t\t\t                                           // WE CAN NOW TRY TO SET THE FULL OBJECT REFERENCE\r\n                                                                   var strleafval = \"finalObjectCheck.cmivalue =\\\"\" + value + \"\\\";\";\r\n\t\t\t\t\t                           var leafVal = eval(strleafval);\r\n");
      out.write("\t\t\t\t\t                           if (leafVal == null){\r\n\t\t\t\t\t\t                       // IT FAILED AT THE FINAL HURDLE...\r\n\t\t\t\t\t\t                       API.ServerSco.lastError = \"201\";\r\n\t\t\t\t\t\t                       return \"false\";\r\n                                                                   }\r\n\t\t\t\t\t                           else{\r\n\t\t\t\t\t\t                       API.ServerSco.lastError = \"0\";\r\n                                                                       return \"true\";\r\n\t\t\t\t\t                           }\r\n                                                               }\r\n                                                               else{\r\n                                                                       // incorrect data type...\r\n\t\t\t                                               API.ServerSco.lastError = \"405\";\r\n                                                                       return \"false\";\r\n                                                               }\r\n\r\n\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t}\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n");
      out.write("\t\t\t\telse {\r\n\t\t\t\t\t// throw an error because 4th arg was not either\r\n\t\t\t\t\t// objectives or correct_responses\r\n\t\t\t\t\tAPI.ServerSco.lastError = \"201\";\r\n\t\t\t\t\treturn \"false\";\r\n\t\t\t\t}\r\n\r\n\t\t\t}\r\n\r\n\t\t}\r\n\t}\r\n\r\n}\r\n\r\n/*\r\n* LMSGetValue.  Method to allow sco to read/access CMI datamodel elements\r\n*/\r\nfunction LMSGetValueMethod(element){\r\n\tif(this.ServerSco.isInitialized==\"true\"){\r\n\t\tvar invalid = \"false\";\r\n\t\tvar cannotHaveChildren = \"false\";\r\n\t\tvar isNotAnArray = \"false\";\r\n\r\n\t\t// this checks to make sure there is at least one dot in the value\r\n\t\tif (element.indexOf(\".\")== -1){\r\n\t\t\tinvalid = \"true\";\r\n\t\t}\r\n\r\n\t\t// dont bother doing this if we have already found an error...\r\n\t\tif (invalid != \"true\"){\r\n\t\t\t// we then loop around the children, making sure they exist one, by one...\r\n\t\t\tvar cmiArray = element.split(\".\");\r\n\t\t\tvar teststring = \"this\";\r\n\t\t\tfor(i=0;i");
      out.write("<cmiArray.length;i++){\r\n\t\t\t\tdoesExist = eval(teststring + \".\" + cmiArray[i]+ \";\");\r\n\t\t\t\tif(doesExist == null){\r\n\t\t\t\t\tinvalid=\"true\";\r\n\t\t\t\t\t// check for invalid _children call\r\n\t\t\t\t\tif (cmiArray[i]==\"_children\"){\r\n\t\t\t\t\t\tcannotHaveChildren = \"true\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\t// check for invalid _count call\r\n\t\t\t\t\tif (cmiArray[i]==\"_count\"){\r\n\t\t\t\t\t\tisNotAnArray = \"true\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\tbreak;\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n\t\t\t\t\tteststring = teststring + \".\" + cmiArray[i];\r\n\t\t\t\t\t// WE NEED TO TRAP THE OBJECTIVES...\r\n\t\t\t\t\tif (teststring==\"this.cmi.objectives\"){\r\n\t\t\t\t\t\treturn dealWithGettingObjectives(element);\r\n\t\t\t\t\t}\r\n\t\t\t\t\t// WE NEED TO TRAP THE INTERACTIONS...\r\n\t\t\t\t\tif (teststring==\"this.cmi.interactions\"){\r\n\t\t\t\t\t\treturn dealWithGettingInteractions(element);\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n\t\t\t}\r\n        }\r\n\r\n\t\t// user tried to call _count on a non-array value\r\n\t\tif (isNotAnArray==\"true\"){\r\n\t\t\tthis.ServerSco.lastError = \"203\";\r\n\t\t\t//alert(\"element does not have _count\");\r\n\t\t\treturn \"\";\r\n\t\t}\r\n\r\n\t\t// user tried to call _children on an element that didnt support it\r\n");
      out.write("\t\tif (cannotHaveChildren==\"true\"){\r\n\t\t\tthis.ServerSco.lastError = \"202\";\r\n\t\t\t//alert(\"element does not have children\");\r\n\t\t\treturn \"\";\r\n\t\t}\r\n\r\n\t\t// if there was some kind of error found above, then...\r\n\t\tif (invalid == \"true\"){\r\n\t\t\tthis.ServerSco.lastError = \"401\";\r\n\t\t\t//alert(\"element doesnt exist in data model:\"+element);\r\n\t\t\treturn \"\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// otherwise its a valid model reference...\r\n\t\t\telementObj = eval (\"this.\"+element);\r\n\t\t}\r\n\r\n   \t\t// next we will check to make sure this element is not writeonly..\r\n\t\tif (elementObj.cmireadStatus == \"writeonly\"){\r\n\t\t\t//alert(\"element is write only\");\r\n\t\t\tthis.ServerSco.lastError = \"404\";\r\n\t\t\treturn \"\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// its okay and user can read it...\r\n\t\t\tthis.ServerSco.lastError = \"0\";\r\n\t\t\treturn elementObj.cmivalue;\r\n\t\t}\r\n\t}\r\n\telse{\r\n\t\t// not initialized...\r\n\t\tthis.ServerSco.lastError = \"301\";\r\n\t\treturn \"\";\r\n\t}\r\n}\r\n\r\n\r\n\r\n/*\r\n* LMSSetValue.  Method to allow sco to write data to CMI datamodel\r\n*/\r\nfunction LMSSetValueMethod(element, value){\r\n\r\n     if (this.ServerSco.isInitialized == \"true\"){\r\n");
      out.write("\t\tvar invalid = \"false\";\r\n\t\tvar cannotHaveChildren = \"false\";\r\n\t\tvar isNotAnArray = \"false\";\r\n\r\n                // check for sco trying to set _children & _count\r\n                //element is a keyword, cannot set...\r\n                if (element.indexOf(\"._children\") != -1 || element.indexOf(\"._count\") != -1){\r\n                        this.ServerSco.lastError = \"402\";\r\n                        return \"false\";\r\n                }\r\n\r\n\t\t// this checks to make sure there is at least one dot in the value\r\n                // if it doesnt, then it cant be a valid CMI model reference\r\n\t\tif (element.indexOf(\".\")== -1){\r\n\t\t\tinvalid = \"true\";\r\n\t\t}\r\n\r\n\t\t// dont bother doing this if we have already found an error...\r\n\t\tif (invalid != \"true\"){\r\n\t\t\t// we then loop around the children, making sure they exist one, by one...\r\n\t\t\tvar cmiArray = element.split(\".\");\r\n\t\t\tvar teststring = \"this\";\r\n\t\t\tfor(i=0;i");
      out.write("<cmiArray.length;i++){\r\n\t\t\t\tdoesExist = eval(teststring + \".\" + cmiArray[i]+ \";\");\r\n\t\t\t\tif(doesExist == null){\r\n\t\t\t\t\tinvalid=\"true\";\r\n\t\t\t\t\t// check for invalid _children call\r\n\t\t\t\t\tif (cmiArray[i]==\"_children\"){\r\n\t\t\t\t\t\tcannotHaveChildren = \"true\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\t// check for invalid _count call\r\n\t\t\t\t\tif (cmiArray[i]==\"_count\"){\r\n\t\t\t\t\t\tisNotAnArray = \"true\";\r\n\t\t\t\t\t}\r\n\t\t\t\t\tbreak;\r\n\t\t\t\t}\r\n\t\t\t\telse{\r\n\t\t\t\t\tteststring = teststring + \".\" + cmiArray[i];\r\n\t\t\t\t\t// WE NEED TO TRAP THE OBJECTIVES...\r\n\t\t\t\t\tif (teststring==\"this.cmi.objectives\"){\r\n\t\t\t\t\t\treturn dealWithSettingObjectives(element, value);\r\n\t\t\t\t\t}\r\n\t\t\t\t\t// WE NEED TO TRAP THE INTERACTIONS...\r\n\t\t\t\t\tif (teststring==\"this.cmi.interactions\"){\r\n\t\t\t\t\t\treturn dealWithSettingInteractions(element, value);\r\n\t\t\t\t\t}\r\n\t\t\t\t}\r\n\t\t\t}\r\n\t\t}\r\n\r\n\t\t// user tried to call _count on a non-array value\r\n\t\tif (isNotAnArray==\"true\"){\r\n\t\t\tthis.ServerSco.lastError = \"203\";\r\n\t\t\t//alert(\"element does not have _count\");\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\r\n\t\t// user tried to call _children on an element that didnt support it\r\n");
      out.write("\t\tif (cannotHaveChildren==\"true\"){\r\n\t\t\tthis.ServerSco.lastError = \"202\";\r\n\t\t\t//alert(\"element does not have children\");\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\r\n\t\t// if there was some kind of error found above, then...\r\n\t\tif (invalid==\"true\"){\r\n\t\t\tthis.ServerSco.lastError = \"401\";\r\n\t\t\t//alert(\"element doesnt exist in data model\");\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t\telse{\r\n\t\t\t// otherwise its a valid model reference...\r\n\t\t\telementObj = eval (\"this.\"+element);\r\n\t\t}\r\n\r\n\t\t// check that its writeable...\r\n\t\tif (elementObj.cmireadStatus == \"readonly\"){\r\n\t\t\t//alert(\"is read only\");\r\n\t\t\tthis.ServerSco.lastError = \"403\";\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t\telse{\r\n                        // check the datatype and vocabulary...\r\n                        var datatype = elementObj.cmidatatype;\r\n                        res = this.ServerSco.checkDataTypeAndVocab(element, value, datatype);\r\n                            if (res == \"true\"){\r\n                                // correct datatype...\r\n                                // cmi.comments need to be appended...\r\n");
      out.write("                                if (element == \"cmi.comments\"){\r\n                                    pre = this.LMSGetValue(\"cmi.comments\");\r\n                                    setString = \"this.\" + element + \".cmivalue =\\\"\" + pre + value + \"\\\";\";\r\n                                }\r\n                                else{\r\n  \t\t\t            setString = \"this.\" + element + \".cmivalue =\\\"\" + value + \"\\\";\";\r\n                                }\r\n\t\t\t        var result = eval(setString);\r\n\t\t\t        this.ServerSco.lastError = \"0\";\r\n\t\t\t        return \"true\";\r\n                            }\r\n                            else{\r\n                                // incorrect data type...\r\n                                this.ServerSco.lastError = \"405\";\r\n                                return \"false\";\r\n                           }\r\n\t\t}\r\n\t}\r\n\telse{\r\n\t\t// not initialized...\r\n\t\tthis.ServerSco.lastError = \"301\";\r\n\t\treturn \"false\";\r\n\t}\r\n}\r\n\r\n\r\nfunction LMSGetErrorStringMethod(errorCode){\r\n\tswitch (errorCode)\r\n \t{\r\n \t\tcase \"0\":   { return \"No error\"; break }\r\n");
      out.write("                case \"101\": { return \"General exception\"; break  }\r\n                case \"201\": { return \"Invalid argument error\"; break }\r\n                case \"202\": { return \"Element cannot have children\"; break  }\r\n\t\tcase \"203\": { return \"Element not an array - Cannot have count\"; break  }\r\n\t\tcase \"301\": { return \"Not initialized\"; break  }\r\n\t\tcase \"401\": { return \"Not implemented error\"; break  }\r\n\t\tcase \"402\": { return \"Invalid set value, element is a keyword\"; break  }\r\n\t\tcase \"403\": { return \"Element is read only\"; break  }\r\n\t\tcase \"404\": { return \"Element is write only\"; break  }\r\n\t\tcase \"405\": { return \"Incorrect Data Type\"; break  }\r\n\t\tdefault:    { return \"\"; break }\r\n\t}\r\n\t// just to be safe...\r\n\treturn;\r\n}\r\n\r\n\r\n\r\nfunction LMSGetLastErrorMethod(){\r\n\treturn this.ServerSco.lastError;\r\n}\r\n\r\n\r\n\r\nfunction LMSGetDiagnosticMethod(errorCode){\r\n\tif (errorCode==\"\"){\r\n\t\terrorCode=this.ServerSco.lastError;\r\n\t}\r\n\tswitch (errorCode)\r\n\t{\r\n\t\tcase \"0\":   { return \"No error. No errors were encountered. Successful API call.\"; break }\r\n");
      out.write("                case \"101\": { return \"General exception. An unexpected error was encountered.\"; break  }\r\n\t\tcase \"201\": { return \"Invalid argument error. A call was made to a DataModel element that does not exist.\"; break }\r\n\t\tcase \"202\": { return \"Element cannot have children. A call was made to an Element that does not support _children\"; break  }\r\n\t\tcase \"203\": { return \"Element is not an array.  Cannot have count. A call was made to an Element that does not support _count.\"; break  }\r\n\t\tcase \"301\": { return \"Not initialized. The SCO has not yet been initialized.  It needs to call LMSInitialize() first.\"; break  }\r\n\t\tcase \"401\": { return \"Not implemented error.  A call was made to a DataModel element that is not supported.\"; break  }\r\n\t\tcase \"402\": { return \"Invalid set value, element is a keyword.  Keyword values cannot be changed\"; break  }\r\n\t\tcase \"403\": { return \"Element is read only.  A call was made to set the value of a read-only element.\"; break  }\r\n\t\tcase \"404\": { return \"Element is write only.  A call was made to get the value of a write-only element.\"; break  }\r\n");
      out.write("\t\tcase \"405\": { return \"Incorrect Data Type.  The syntax of a call to change an element was incorrect.\"; break  }\r\n\t\tdefault:    { return \"\"; break }\r\n\t}\r\n}\r\n\r\n\r\n\r\n/*\r\n* --------------------------------------------------------------------------------------------------\r\n*\tDatatype and vocabulary checking\r\n* --------------------------------------------------------------------------------------------------\r\n*/\r\n\r\n/*\r\n* Method to check the datatype and vocabulary of an element\r\n* returns true or false...\r\n*/\r\nfunction scoCheckDataTypeAndVocab (element, value, datatype){\r\n    switch (datatype)\r\n \t{\r\n            case \"CMIBlank\":   { return checkCMIBlank(value); break }\r\n            case \"CMIBoolean\": { return checkCMIBoolean(value); break  }\r\n            case \"CMIDecimal\": { return checkCMIDecimal(value); break }\r\n            case \"CMIFeedback\": { return  checkCMIFeedback(element, value); break  }\r\n\t    case \"CMIIdentifier\": { return  checkCMIIdentifier(value); break  }\r\n\t    case \"CMIInteger\": { return checkCMIInteger(value); break  }\r\n");
      out.write("\t    case \"CMISInteger\": { return checkCMISInteger(element, value); break  }\r\n\t    case \"CMIString255\": { return checkCMIString255(value); break  }\r\n\t    case \"CMIString4096\": { return checkCMIString4096(value); break  }\r\n\t    case \"CMITime\": { return checkCMITime(value); break  }\r\n\t    case \"CMITimespan\": { return checkCMITimespan(value); break  }\r\n\t    case \"CMIVocabularyCredit\": { return checkCMIVocabularyCredit(value); break  }\r\n\t    case \"CMIVocabularyStatus\": { return checkCMIVocabularyStatus(element, value); break  }\r\n\t    case \"CMIVocabularyEntry\": { return checkCMIVocabularyEntry(value); break  }\r\n\t    case \"CMIVocabularyMode\": { return checkCMIVocabularyMode(value); break  }\r\n\t    case \"CMIVocabularyExit\": { return checkCMIVocabularyExit(value); break  }\r\n\t    case \"CMIVocabularyTimeLimitAction\": { return checkCMIVocabularyTimeLimitAction(value); break  }\r\n\t    case \"CMIVocabularyInteraction\": { return checkCMIVocabularyInteraction(value); break  }\r\n\t    case \"CMIVocabularyResult\": { return checkCMIVocabularyResult(value); break  }\r\n");
      out.write("            case \"CMIDecimalOrCMIBlank\": { return checkCMIDecimalOrCMIBlank(value); break  }\r\n\t    default:    { return \"true\"; break }\r\n\t}\r\n}\r\n\r\nfunction checkCMIDecimalOrCMIBlank(value){\r\n\r\n    var isBlank = checkCMIBlank(value);\r\n    var isCMIDecimal = checkCMIDecimal(value);\r\n    if (isBlank == \"true\" || isCMIDecimal == \"true\"){\r\n        if (value > 100 || value ");
      out.write("< 0){\r\n            return \"false\";\r\n        }\r\n        else{\r\n            return \"true\";\r\n        }\r\n    }else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyResult(value){\r\n    var ans = checkCMIDecimal(value);\r\n    if (ans == \"true\"){\r\n        return \"true\";\r\n    }\r\n    if (value == \"correct\" || value == \"wrong\" ||\r\n        value == \"unanticipated\" || value == \"neutral\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\n\r\nfunction checkCMIVocabularyInteraction(value){\r\n    if (value == \"true-false\" || value == \"choice\" ||\r\n        value == \"fill-in\" || value == \"matching\" ||\r\n        value == \"performance\" || value == \"likert\" ||\r\n        value == \"sequencing\" || value == \"numeric\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyTimeLimitAction(value){\r\n    if (value == \"exit,message\" || value == \"exit,no message\" ||\r\n        value == \"continue,message\" || value == \"continue,no message\"){\r\n        return \"true\";\r\n");
      out.write("    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyExit(value){\r\n    if (value == \"time-out\" || value == \"suspend\" ||\r\n        value == \"logout\" || value == \"\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyMode(value){\r\n    if (value == \"normal\" || value == \"review\" || value == \"browse\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyEntry(value){\r\n    if (value == \"ab-initio\" || value == \"resume\" || value == \"\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyStatus(element, value){\r\n    // sco cannot lesson_status to not attempted\r\n    if (element == \"cmi.core.lesson_status\" && value == \"not attempted\"){\r\n        return false;\r\n    }\r\n    if (value == \"passed\" || value == \"completed\" ||\r\n        value == \"failed\" || value == \"incomplete\" ||\r\n        value == \"browsed\" || value == \"not attempted\"){\r\n");
      out.write("        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIVocabularyCredit(value){\r\n    if (value == \"credit\" || value == \"no-credit\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\n\r\nfunction checkCMITimespan(value){\r\n   // must have some colons...\r\n   if (value.indexOf(\":\") == -1){\r\n       return \"false\";\r\n   }\r\n   // must contain at least 2 colons, giving 3 array elements...\r\n   var cmiArray = value.split(\":\");\r\n   if (cmiArray.length ");
      out.write("< 3){\r\n      return \"false\";\r\n   }\r\n   // hours must be 4,3 or 2 digits...\r\n   if (cmiArray[0].length ");
      out.write("< 2 || cmiArray[0].length > 4  ){\r\n      return \"false\";\r\n   }\r\n   // minutes must be 2 digits...\r\n   if (cmiArray[1].length != 2){\r\n      return \"false\";\r\n   }\r\n   // must be numbers...\r\n   if (isNaN(cmiArray[0]) || isNaN(cmiArray[1]) || isNaN(cmiArray[2])){\r\n      return \"false\";\r\n   }\r\n   // 24hr clock for hours...\r\n   if (parseInt(cmiArray[0]) ");
      out.write("< 0){\r\n      return \"false\";\r\n   }\r\n   // parse minutes\r\n   // NOTE: Seems illegal to have 99 minutes, but ADL 1.2\r\n   // SCORM Conformance Test Suite does this? I'll do the same...\r\n   // if (parseInt(cmiArray[1]) ");
      out.write("< 0 || parseInt(cmiArray[1]) > 59){\r\n   if (parseInt(cmiArray[1]) ");
      out.write("< 0){\r\n      return \"false\";\r\n   }\r\n   // check for decimal place...\r\n   if (cmiArray[2].indexOf(\".\") != -1){\r\n       var cmiDecArray = cmiArray[2].split(\".\");\r\n       // can only be 2 values here...\r\n       if (cmiDecArray.length != 2){\r\n           return \"false\";\r\n       }\r\n       // again they must be numbers...\r\n       if (isNaN(cmiDecArray[0]) || isNaN(cmiDecArray[1])){\r\n           return \"false\";\r\n       }\r\n       // only two digits allowed for seconds...\r\n       if (cmiDecArray[0].length != 2){\r\n           return \"false\";\r\n       }\r\n       // make sure there is less than 60 seconds here...\r\n       if (parseInt(cmiDecArray[0]) > 59 ){\r\n          return \"false\";\r\n       }\r\n       // only one or two digits allowed for milliseconds...\r\n       if (cmiDecArray[1].length > 2){\r\n           return \"false\";\r\n       }\r\n   }\r\n   else{\r\n       // no dots, so must be no milliseconds...\r\n       // make sure length is 2\r\n       if (cmiArray[2].length != 2){\r\n           return \"false\";\r\n       }\r\n       // make sure there is less than 60 seconds here...\r\n");
      out.write("       if (parseInt(cmiArray[2]) > 59 ){\r\n          return \"false\";\r\n       }\r\n   }\r\n   // got up to here, then value okay...\r\n   return \"true\";\r\n}\r\n\r\nfunction checkCMITime(value){\r\n\r\n   // must have some colons...\r\n   if (value.indexOf(\":\") == -1){\r\n       return \"false\";\r\n   }\r\n   // must contain at least 2 colons, giving 3 array elements...\r\n   var cmiArray = value.split(\":\");\r\n   if (cmiArray.length ");
      out.write("< 3){\r\n      return \"false\";\r\n   }\r\n   // hours & minutes must be 2 digits...\r\n   if (cmiArray[0].length != 2 || cmiArray[1].length != 2){\r\n      return \"false\";\r\n   }\r\n   // must be numbers...\r\n   if (isNaN(cmiArray[0]) || isNaN(cmiArray[1]) || isNaN(cmiArray[2])){\r\n      return \"false\";\r\n   }\r\n   // 24hr clock for hours...\r\n   if (parseInt(cmiArray[0]) ");
      out.write("< 0 || parseInt(cmiArray[0]) > 23){\r\n      return \"false\";\r\n   }\r\n   // parse minutes\r\n   if (parseInt(cmiArray[1]) ");
      out.write("< 0 || parseInt(cmiArray[1]) > 59){\r\n      return \"false\";\r\n   }\r\n   // check for decimal place...\r\n   if (cmiArray[2].indexOf(\".\") != -1){\r\n       var cmiDecArray = cmiArray[2].split(\".\");\r\n       // can only be 2 values here...\r\n       if (cmiDecArray.length != 2){\r\n           return \"false\";\r\n       }\r\n       // again they must be numbers...\r\n       if (isNaN(cmiDecArray[0]) || isNaN(cmiDecArray[1])){\r\n           return \"false\";\r\n       }\r\n       // only two digits allowed for seconds...\r\n       if (cmiDecArray[0].length != 2){\r\n           return \"false\";\r\n       }\r\n       // make sure there is less than 60 seconds here...\r\n       if (parseInt(cmiDecArray[0]) > 59 ){\r\n          return \"false\";\r\n       }\r\n       // only one or two digits allowed for milliseconds...\r\n       if (cmiDecArray[1].length > 2){\r\n           return \"false\";\r\n       }\r\n   }\r\n   else{\r\n       // no dots, so must be no milliseconds...\r\n       // make sure length is 2\r\n       if (cmiArray[2].length != 2){\r\n           return \"false\";\r\n       }\r\n");
      out.write("       // make sure there is less than 60 seconds here...\r\n       if (parseInt(cmiArray[2]) > 59 ){\r\n          return \"false\";\r\n       }\r\n   }\r\n   // got up to here, then value okay...\r\n   return \"true\";\r\n}\r\n\r\n\r\nfunction checkCMIString4096(value){\r\n    if (value.length ");
      out.write("<= 4096){\r\n       return \"true\";\r\n    }\r\n    else{\r\n       return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMIString255(value){\r\n    if (value.length ");
      out.write("<= 255){\r\n       return \"true\";\r\n    }\r\n    else{\r\n       return \"false\";\r\n    }\r\n}\r\n\r\nfunction checkCMISInteger(element, value){\r\n    if(isNaN(value)){\r\n        return \"false\";\r\n    }\r\n    else{\r\n        var num = parseInt(value);\r\n        if (num >= -32768 && num ");
      out.write("<= 32768){\r\n            if (element == \"cmi.student_preference.audio\"){\r\n                if (num ");
      out.write("< -1 || num > 100){\r\n                    return \"false\";\r\n                }\r\n                else{\r\n                    return \"true\";\r\n                }\r\n            }\r\n            else if (element == \"cmi.student_preference.speed\"){\r\n                if (num ");
      out.write("< -100 || num > 100){\r\n                    return \"false\";\r\n                }\r\n                else{\r\n                    return \"true\";\r\n                }\r\n            }\r\n            else if (element == \"cmi.student_preference.text\"){\r\n                if (num ");
      out.write("< -1 || num > 1){\r\n                    return \"false\";\r\n                }\r\n                else{\r\n                    return \"true\";\r\n                }\r\n            }\r\n            else{\r\n                return \"true\";\r\n            }\r\n        }\r\n        else{\r\n            return \"false\";\r\n        }\r\n    }\r\n}\r\n\r\nfunction checkCMIInteger(value){\r\n    if(isNaN(value)){\r\n        return \"false\";\r\n    }\r\n    else{\r\n        var num = parseInt(value);\r\n        if (num >= 0 && num ");
      out.write("<= 65536){\r\n            return \"true\";\r\n        }\r\n        else{\r\n            return \"false\";\r\n        }\r\n    }\r\n}\r\n\r\nfunction checkCMIIdentifier(value){\r\n    var SPACE = ' ';\r\n    var TAB = '\\t';\r\n    var CRETURN = '\\r';\r\n    var LINEFEED = '\\n';\r\n    if (value.indexOf(SPACE) == -1 && value.indexOf(TAB) == -1\r\n     && value.indexOf(CRETURN) == -1 && value.indexOf(LINEFEED) == -1){\r\n        if (value.length > 0 && value.length ");
      out.write("< 256){\r\n            return \"true\";\r\n        }\r\n        else{\r\n            return \"false\";\r\n        }\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\n\r\n\r\nfunction checkCMIFeedback(element, value){\r\n    // allow user to edit var at top of page to disable this checking...\r\n    if (looseChecking == \"false\"){\r\n        // need to find the type (if its set)\r\n        var cmiArray = element.split(\".\");\r\n\t    // need to check cmiArray[2] to see if its a number\r\n\t    if (isNaN(cmiArray[2])){\r\n            // this should be a number. However, Err on the side of caution...\r\n            return \"false\";\r\n\t    }\r\n        // make sure that this interaction already exists...\r\n        var res = API.LMSGetValue(\"cmi.interactions._count\");\r\n        if (parseInt(cmiArray[2]) >= parseInt(res)){\r\n            // then this interaction does not exist.. However, Err on the side of caution...\r\n            return \"false\";\r\n        }\r\n        // Up to here? - then get the type\r\n        var theType = \"cmi.interactions.intArray(\"+cmiArray[2]+\").type\";\r\n");
      out.write("        elementObj = eval(\"API.\"+theType+\";\");\r\n        if (elementObj == null){\r\n            return \"false\";\r\n        }\r\n        datatype = elementObj.cmivalue;\r\n\r\n        if (datatype == null){\r\n            return \"false\";\r\n        }\r\n        // its not null, so it equals something, so...\r\n        switch (datatype)\r\n        {\r\n            case \"true-false\":   { return checkTrueFalse(value); break }\r\n            case \"choice\":   { return checkChoice(value); break }\r\n            case \"fill-in\":   { return checkFillIn(value); break }\r\n            case \"numeric\":   { return checkCMIDecimal(value); break }\r\n            case \"likert\":   { return checkLikert(value); break }\r\n            case \"matching\":   { return checkMatching(value); break }\r\n            case \"performance\":   { return checkCMIString255(value); break }\r\n            case \"sequencing\":   { return checkSequencing(value); break }\r\n            // if its not been set then we should return false.  That would mean\r\n            // that a cmi.interaction.n.type MUST have a value and cannot be empty\r\n");
      out.write("            default:   { return \"false\"; break }\r\n        }\r\n    }\r\n    else{\r\n        return \"true\";\r\n    }\r\n\r\n}\r\n\r\nfunction checkMatching(value){\r\n  // check for n.n\r\n  var TEST_VAL = /^[a-z,0-9]{1}.{1}[a-z,0-9]{1}$/;\r\n  // check for n.n,n.n,n.n etc\r\n  var TEST_VAL2 = /^[a-z,0-9]{1}.{1}[a-z,0-9]{1},{1}([a-z,0-9]{1}.{1}[a-z,0-9]{1},{1})*[a-z,0-9]{1}.{1}[a-z,0-9]{1}$/;\r\n  // check for {n.n,n.n,n.n etc }\r\n  var TEST_VAL3 = /^{[a-z,0-9]{1}.{1}[a-z,0-9]{1},{1}([a-z,0-9]{1}.{1}[a-z,0-9]{1},{1})*[a-z,0-9]{1}.{1}[a-z,0-9]{1}}$/;\r\n\r\n  if (TEST_VAL.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else if (TEST_VAL2.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else if (TEST_VAL3.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else{\r\n      return \"false\";\r\n  }\r\n}\r\n\r\n\r\nfunction checkSequencing(value){\r\n\r\n  // test for single a-z 0-9\r\n  var TEST_VAL = /^[a-z,0-9]{1}$/;\r\n\r\n  // test for format 1,2,3,a,b,c\r\n  var TEST_VAL2 = /^[a-z,0-9]{1},{1}([a-z,0-9],)*[a-z,0-9]{1}$/;\r\n\r\n  if (TEST_VAL.test(value)) {\r\n      return \"true\";\r\n  }\r\n");
      out.write("  else if (TEST_VAL2.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else{\r\n      return \"false\";\r\n  }\r\n}\r\n\r\nfunction checkChoice(value){\r\n  // test for single a-z 0-9\r\n  var TEST_VAL = /^[a-z,0-9]{1}$/;\r\n\r\n  // test for format 1,2,3,a,b,c\r\n  var TEST_VAL2 = /^[a-z,0-9]{1},{1}([a-z,0-9],)*[a-z,0-9]{1}$/;\r\n\r\n  // test for format {1,2,3,a,b,c}\r\n  var TEST_VAL3 = /^{[a-z,0-9]{1},{1}([a-z,0-9],)*[a-z,0-9]{1}}$/;\r\n\r\n  if (TEST_VAL.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else if (TEST_VAL2.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else if (TEST_VAL3.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else{\r\n      return \"false\";\r\n  }\r\n}\r\n\r\n\r\nfunction checkFillIn(value){\r\n    return checkCMIString255(value);\r\n}\r\n\r\n\r\nfunction checkTrueFalse(value){\r\n    if (value == \"0\" || value == \"1\" || value == \"t\" || value == \"f\"){\r\n        return \"true\";\r\n    }\r\n    else{\r\n        return \"false\";\r\n    }\r\n}\r\n\r\n\r\nfunction checkLikert(value){\r\n  if (value.length == 0){\r\n      return \"true\";\r\n  }\r\n  if (value.length > 1){\r\n      return \"false\";\r\n");
      out.write("  }\r\n  var TEST_VAL = /^[a-z,0-9]{1}$/;\r\n  if (TEST_VAL.test(value)) {\r\n      return \"true\";\r\n  }\r\n  else{\r\n      return \"false\";\r\n  }\r\n}\r\n\r\n\r\nfunction checkCMIDecimal(value){\r\n   if (isNaN(value)){\r\n        return \"false\";\r\n   }\r\n   else{\r\n        return \"true\";\r\n   }\r\n}\r\n\r\nfunction checkCMIBoolean(value){\r\n   if (value == \"true\" || value == \"false\"){\r\n        return \"true\";\r\n   }\r\n   else{\r\n        return \"false\";\r\n   }\r\n}\r\n\r\nfunction checkCMIBlank(value){\r\n   if (value != \"\"){\r\n       return \"false\";\r\n   }\r\n   else{\r\n       return \"true\";\r\n   }\r\n}\r\n\r\n\r\n/*\r\n* ----------------------------------------------------------------------------------------------------\r\n*\r\n*\tThe CMI Client side data models\r\n*\r\n* ----------------------------------------------------------------------------------------------------\r\n*/\r\n\r\n\r\n\r\nfunction CMIModel (){\r\n\tthis._version = new CMIComponent(\"_version\", \"3.4\", \"readonly\", \"\");\r\n\tthis.core = new CMICoreModel;\r\n\tthis.suspend_data = new CMIComponent(\"suspend_data\", \"\", \"both\", \"CMIString4096\");\r\n");
      out.write("\tthis.launch_data = new CMIComponent(\"launch_data\",\"\",\"readonly\", \"CMIString4096\");\r\n\tthis.comments = new CMIComponent(\"comments\",\"\",\"both\", \"CMIString4096\");\r\n\tthis.comments_from_lms = new CMIComponent(\"comments_from_lms\",\"\",\"readonly\", \"CMIString4096\");\r\n\tthis.objectives = new ObjectivesModel;\r\n\tthis.student_data = new StudentDataModel;\r\n\tthis.student_preference = new StudentPreferenceModel;\r\n\tthis.interactions = new InteractionsModel;\r\n}\r\n\r\n\r\nfunction CMICoreModel(){\r\n\tthis._children = new CMIComponent(\"_children\", \"student_id,student_name,lesson_location,credit,lesson_status,entry,score,total_time,lesson_mode,exit,session_time\", \"readonly\", \"CMIString255\");\r\n\tthis.student_id = new CMIComponent(\"student_id\", \"\", \"readonly\", \"CMIIdentifier\");\r\n\tthis.student_name = new CMIComponent(\"student_name\", \"\", \"readonly\", \"CMIString255\");\r\n\tthis.lesson_location = new CMIComponent(\"lesson_location\", \"\", \"both\", \"CMIString255\");\r\n\tthis.credit = new CMIComponent(\"credit\", \"\", \"readonly\", \"CMIVocabularyCredit\");\r\n\tthis.lesson_status = new CMIComponent(\"lesson_status\", \"\", \"both\", \"CMIVocabularyStatus\");\r\n");
      out.write("\tthis.entry = new CMIComponent(\"entry\",\"\",\"readonly\", \"CMIVocabularyEntry\");\r\n\tthis.score = new CMIScore;\r\n\tthis.total_time = new CMIComponent(\"total_time\", \"\", \"readonly\", \"CMITimespan\");\r\n\tthis.lesson_mode = new CMIComponent(\"lesson_mode\", \"\", \"readonly\", \"CMIVocabularyMode\");\r\n\tthis.exit = new CMIComponent(\"exit\", \"\", \"writeonly\", \"CMIVocabularyExit\");\r\n\tthis.session_time = new CMIComponent(\"session_time\", \"\", \"writeonly\", \"CMITimespan\");\r\n}\r\n\r\n\r\nfunction CMIScore(){\r\n\tthis._children = new  CMIComponent(\"_children\", \"raw,min,max\", \"readonly\", \"CMIString255\");\r\n\tthis.raw = new CMIComponent(\"raw\", \"\", \"both\", \"CMIDecimalOrCMIBlank\");\r\n\tthis.max = new CMIComponent(\"max\", \"\", \"both\", \"CMIDecimalOrCMIBlank\");\r\n\tthis.min = new CMIComponent(\"min\", \"\", \"both\", \"CMIDecimalOrCMIBlank\");\r\n}\r\n\r\n\r\nfunction StudentPreferenceModel(){\r\n\tthis._children = new CMIComponent(\"_children\", \"audio,language,speed,text\", \"readonly\", \"CMIString255\");\r\n\tthis.audio = new CMIComponent(\"audio\", \"0\", \"both\", \"CMISInteger\");\r\n\tthis.language = new CMIComponent(\"language\", \"\", \"both\", \"CMIString255\");\r\n");
      out.write("\tthis.speed = new CMIComponent(\"speed\", \"0\", \"both\", \"CMISInteger\");\r\n\tthis.text = new CMIComponent(\"text\", \"0\", \"both\", \"CMISInteger\");\r\n}\r\n\r\n\r\nfunction StudentDataModel(){\r\n\tthis._children = new CMIComponent(\"_count\", \"mastery_score,max_time_allowed,time_limit_action\", \"readonly\", \"CMIString255\");\r\n\tthis.mastery_score = new CMIComponent(\"mastery_score\", \"\", \"readonly\", \"CMIDecimal\");\r\n\tthis.max_time_allowed = new CMIComponent(\"max_time_allowed\", \"\", \"readonly\", \"CMITimespan\");\r\n\tthis.time_limit_action = new CMIComponent(\"time_limit_action\", \"\", \"readonly\", \"CMIVocabularyTimeLimitAction\");\r\n}\r\n\r\n\r\n\r\n/*\r\n*  The CMI objectives model\r\n*/\r\n\r\nfunction ObjectivesModel(){\r\n\tthis._children = new CMIComponent(\"_children\", \"id,score,status\", \"readonly\", \"CMIString255\");\r\n\tthis._count = new CMIComponent(\"_count\", 0, \"readonly\", \"CMIInteger\");\r\n\tthis.objArray = ObjectiveArrayModel;\r\n\tthis.objArr = new Array();\r\n}\r\n\r\nfunction ObjectiveArrayModel(index){\r\n\r\n\tif(index>this._count.cmivalue-1){\r\n\t\tif (index == this._count.cmivalue){\r\n");
      out.write("\t\t\t// then create new one...\r\n\t\t\tthis.objArr[index] = new singleObjectiveModel();\r\n\t\t\tthis._count.cmivalue = this._count.cmivalue + 1;\r\n\t\t\treturn this.objArr[index];\r\n\t\t}\r\n\t\telse{\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t}\r\n\telse{\r\n\t\t// we must be talking about this one so return object..\r\n\t\treturn this.objArr[index];\r\n\t}\r\n}\r\n\r\n\r\nfunction singleObjectiveModel(){\r\n\tthis.id = new CMIComponent(\"id\", \"\", \"both\", \"CMIIdentifier\");\r\n\tthis.score = new objectiveScoreModel;\r\n\tthis.status = new CMIComponent(\"status\", \"\", \"both\", \"CMIVocabularyStatus\");\r\n}\r\n\r\nfunction objectiveScoreModel(){\r\n\tthis._children = new CMIComponent(\"_children\", \"raw,min,max\", \"readonly\", \"CMIString255\");\r\n\tthis.raw = new CMIComponent(\"raw\", \"\", \"both\", \"CMIDecimalOrCMIBlank\");\r\n\tthis.min = new CMIComponent(\"min\", \"\", \"both\", \"CMIDecimalOrCMIBlank\");\r\n\tthis.max = new CMIComponent(\"max\", \"\", \"both\", \"CMIDecimalOrCMIBlank\");\r\n}\r\n\r\n\r\n\r\n/*\r\n*  The CMI interactions model\r\n*/\r\n\r\nfunction InteractionsModel(){\r\n\tthis._children = new CMIComponent(\"_children\", \"id,objectives,time,type,correct_responses,weighting,student_response,result,latency\", \"readonly\", \"CMIString255\");\r\n");
      out.write("\tthis._count = new CMIComponent(\"_count\", 0, \"readonly\", \"CMIInteger\");\r\n\tthis.intArray = InteractionsArrayModel;\r\n\tthis.intArr = new Array();\r\n}\r\n\r\n\r\nfunction InteractionsArrayModel(index){\r\n\r\n\tif(index>this._count.cmivalue-1){\r\n\t\tif (index == this._count.cmivalue){\r\n\t\t\t// then create new one...\r\n\t\t\tthis.intArr[index] = new singleInteractionModel();\r\n\t\t\tthis._count.cmivalue = this._count.cmivalue + 1;\r\n\t\t\treturn this.intArr[index];\r\n\t\t}\r\n\t\telse{\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t}\r\n\telse{\r\n\t\t// we must be talking about this one so return object..\r\n\t\treturn this.intArr[index];\r\n\t}\r\n}\r\n\r\n\r\nfunction singleInteractionModel(){\r\n\tthis.id = new CMIComponent(\"id\", \"\", \"writeonly\", \"CMIIdentifier\");\r\n\tthis.objectives = new ObjectivesInteractionModel;\r\n\tthis.time = new CMIComponent(\"time\", \"\", \"writeonly\", \"CMITime\");\r\n\tthis.type = new CMIComponent(\"type\", \"\", \"writeonly\", \"CMIVocabularyInteraction\");\r\n\tthis.correct_responses = new CorrectResponsesInteractionModel;\r\n\tthis.weighting = new CMIComponent(\"weighting\", \"\", \"writeonly\", \"CMIDecimal\");\r\n");
      out.write("\tthis.student_response = new CMIComponent(\"student_response\", \"\", \"writeonly\", \"CMIFeedback\");\r\n\tthis.result = new CMIComponent(\"result\", \"\", \"writeonly\", \"CMIVocabularyResult\");\r\n\tthis.latency = new CMIComponent(\"latency\", \"\", \"writeonly\", \"CMITimespan\");\r\n}\r\n\r\n\r\nfunction ObjectivesInteractionModel(){\r\n\tthis._count = new CMIComponent(\"_count\", 0, \"readonly\", \"CMIInteger\");\r\n\tthis.objectivesInteractionArray = SingleObjectivesInteractionModel;\r\n\tthis.objectivesInteractionArr = new Array();\r\n}\r\n\r\n\r\nfunction SingleObjectivesInteractionModel(index){\r\n\tif(index>this._count.cmivalue-1){\r\n\t\tif (index == this._count.cmivalue){\r\n\t\t\t// then create new one...\r\n\t\t\tthis.objectivesInteractionArr[index] = new SingleItemObjectivesInteractionModel();\r\n\t\t\tthis._count.cmivalue = this._count.cmivalue + 1;\r\n\t\t\treturn this.objectivesInteractionArr[index];\r\n\t\t}\r\n\t\telse{\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t}\r\n\telse{\r\n\t\t// we must be talking about this one so return object..\r\n\t\treturn this.objectivesInteractionArr[index];\r\n\t}\r\n}\r\n\r\n\r\nfunction SingleItemObjectivesInteractionModel(){\r\n");
      out.write("\tthis.id = new CMIComponent(\"id\", \"\", \"writeonly\", \"CMIIdentifier\");\r\n}\r\n\r\n\r\n\r\nfunction CorrectResponsesInteractionModel(){\r\n\tthis._count = new CMIComponent(\"_count\", 0, \"readonly\", \"CMIInteger\");\r\n\tthis.correctResponsesInteractionArray = SingleCorrectResponsesInteractionModel;\r\n\tthis.correctResponsesInteractionArr = new Array();\r\n}\r\n\r\n\r\nfunction SingleCorrectResponsesInteractionModel(index){\r\n\tif(index>this._count.cmivalue-1){\r\n\t\tif (index == this._count.cmivalue){\r\n\t\t\t// then create new one...\r\n\t\t\tthis.correctResponsesInteractionArr[index] = new SingleItemCorrectResponsesInteractionModel();\r\n\t\t\tthis._count.cmivalue = this._count.cmivalue + 1;\r\n\t\t\treturn this.correctResponsesInteractionArr[index];\r\n\t\t}\r\n\t\telse{\r\n\t\t\treturn \"false\";\r\n\t\t}\r\n\t}\r\n\telse{\r\n\t\t// we must be talking about this one so return object..\r\n\t\treturn this.correctResponsesInteractionArr[index];\r\n\t}\r\n}\r\n\r\n\r\nfunction SingleItemCorrectResponsesInteractionModel(){\r\n\tthis.pattern = new CMIComponent(\"pattern\", \"\", \"writeonly\", \"CMIFeedback\");\r\n}\r\n\r\n\r\n");
      out.write("\r\n\r\n/*\r\n*  ...And most importantly, we must finally create our daddy object API...\r\n*/\r\n\r\nvar API = new GenericAPIAdaptor;\r\n\r\n\r\nfunction quitLMS(){\r\n  var needToUpdateModelFirst = \"");
      out.print(loadModelFlag);
      out.write("\";\r\n  if (needToUpdateModelFirst == \"true\"){\r\n    // Can't do this as its readonly  - API.LMSSetValue(\"cmi.core.entry\", \"resume\");\r\n    // so overide this by directly accessing object...\r\n    var setString = \"API.cmi.core.entry.cmivalue =\\\"resume\\\";\";\r\n    var result = eval(setString);\r\n    //\r\n    // exit is writeable, so do it the normal way\r\n    API.LMSSetValue(\"cmi.core.exit\", \"suspend\");\r\n    // write evrything back to the server\r\n    API.LMSCommit(\"\");\r\n    // let our onunload handler call lmsfinish\r\n    //API.LMSFinish(\"\");\r\n  }\r\n  window.top.close();\r\n}\r\n\r\n\r\n\r\n/*\r\n*\r\n*\r\n*/\r\nfunction showCurrentModelState(infoOrForm){\r\n\r\n\tvar divider = \"\";\r\n\tvar titles = \"\";\r\n\tif (infoOrForm == \"info\"){\r\n\t\tdivider = \"\\n\";\r\n                equals = \"=\";\r\n\t\ttitles = \"Current client CMI Datamodel\\n\\n\";\r\n\t}\r\n\telse{\r\n                equals = \"~\";\r\n\t\tdivider = \"^\";\r\n\t\ttitles = \"\";\r\n\t}\r\n\r\n\ta = \"cmi.core.student_id\" + equals + API.cmi.core.student_id.cmivalue + divider;\r\n\tb = \"cmi.core.student_name\" + equals + API.cmi.core.student_name.cmivalue + divider;\r\n");
      out.write("\tc = \"cmi.core.lesson_location\" + equals + API.cmi.core.lesson_location.cmivalue + divider;\r\n\td = \"cmi.core.credit\" + equals + API.cmi.core.credit.cmivalue + divider;\r\n\te = \"cmi.core.lesson_status\" + equals + API.cmi.core.lesson_status.cmivalue + divider;\r\n\tf = \"cmi.core.entry\" + equals + API.cmi.core.entry.cmivalue + divider;\r\n\tg = \"cmi.core.score.raw\" + equals + API.cmi.core.score.raw.cmivalue + divider;\r\n\th = \"cmi.core.score.max\" + equals + API.cmi.core.score.max.cmivalue + divider;\r\n\ti = \"cmi.core.score.min\" + equals + API.cmi.core.score.min.cmivalue + divider;\r\n\tj = \"cmi.core.total_time\" + equals + API.cmi.core.total_time.cmivalue + divider;\r\n\tk = \"cmi.core.lesson_mode\" + equals + API.cmi.core.lesson_mode.cmivalue + divider;\r\n\tl = \"cmi.core.exit\" + equals + API.cmi.core.exit.cmivalue + divider;\r\n\tm = \"cmi.core.session_time\" + equals + API.cmi.core.session_time.cmivalue + divider;\r\n\tn = \"cmi.suspend_data\" + equals + API.cmi.suspend_data.cmivalue + divider;\r\n\to = \"cmi.launch_data\" + equals + API.cmi.launch_data.cmivalue + divider;\r\n");
      out.write("\tp = \"cmi.comments\" + equals + API.cmi.comments.cmivalue + divider;\r\n\tq = \"cmi.comments_from_lms\" + equals + API.cmi.comments_from_lms.cmivalue + divider;\r\n\tr = \"cmi.objectives._count\" + equals + API.cmi.objectives._count.cmivalue + divider;\r\n\r\n\tvar s = \"\";\r\n\tvar objectivesCount = API.cmi.objectives._count.cmivalue;\r\n\tfor (count=0; count ");
      out.write("< objectivesCount; count++){\r\n\t\tobjHandle = API.cmi.objectives.objArray(count);\r\n\t\tidval = objHandle.id.cmivalue;\r\n\t\tscoreRaw = objHandle.score.raw.cmivalue;\r\n\t\tscoreMax = objHandle.score.max.cmivalue;\r\n\t\tscoreMin = objHandle.score.min.cmivalue;\r\n                statval = objHandle.status.cmivalue;\r\n\t\ts = s + \"cmi.objectives.\" + count + \".id\" + equals + idval + divider;\r\n\t\ts = s + \"cmi.objectives.\" + count + \".score.raw\" + equals + scoreRaw + divider;\r\n\t\ts = s + \"cmi.objectives.\" + count + \".score.max\" + equals + scoreMax + divider;\r\n\t\ts = s + \"cmi.objectives.\" + count + \".score.min\" + equals + scoreMin + divider;\r\n                s = s + \"cmi.objectives.\" + count + \".status\" + equals + statval + divider;\r\n\t}\r\n\r\n\r\n    v = \"cmi.student_data.mastery_score\" + equals + API.cmi.student_data.mastery_score.cmivalue + divider;\r\n    w = \"cmi.student_data.max_time_allowed\" + equals + API.cmi.student_data.max_time_allowed.cmivalue + divider;\r\n    x = \"cmi.student_data.time_limit_action\" + equals + API.cmi.student_data.time_limit_action.cmivalue + divider;\r\n");
      out.write("\r\n    y = \"cmi.student_preference.audio\" + equals + API.cmi.student_preference.audio.cmivalue + divider;\r\n    z = \"cmi.student_preference.language\" + equals + API.cmi.student_preference.language.cmivalue + divider;\r\n    zz = \"cmi.student_preference.speed\" + equals + API.cmi.student_preference.speed.cmivalue + divider;\r\n    zzz = \"cmi.student_preference.text\" + equals + API.cmi.student_preference.text.cmivalue + divider;\r\n\r\n\tt = \"cmi.interactions._count\" + equals + API.cmi.interactions._count.cmivalue + divider;\r\n\r\n\tvar u = \"\";\r\n\tvar interactionsCount = API.cmi.interactions._count.cmivalue\r\n\tfor (intcount=0; intcount ");
      out.write("< interactionsCount; intcount++){\r\n\t\tintHandle = API.cmi.interactions.intArray(intcount);\r\n\r\n\t\tidval = intHandle.id.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".id\" + equals + idval + divider;\r\n\r\n\t\tinterObjCount = intHandle.objectives._count.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".objectives._count\" + equals + interObjCount + divider;\r\n\r\n\t\tfor (objcount=0; objcount ");
      out.write("< interObjCount; objcount++){\r\n\t\t\t interactionObjectiveHandle = intHandle.objectives.objectivesInteractionArray(objcount);\r\n\t\t\t objid = interactionObjectiveHandle.id.cmivalue;\r\n\t\t\t u = u + \"cmi.interactions.\" + intcount + \".objectives.\" + objcount + \".id\" + equals + objid + divider;\r\n\t\t}\r\n\r\n\t\tsrCount = intHandle.correct_responses._count.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".correct_responses._count\" + equals + srCount + divider;\r\n\r\n\t\tfor (objcount=0; objcount ");
      out.write("< srCount; objcount++){\r\n\t\t\t interactionSRHandle = intHandle.correct_responses.correctResponsesInteractionArray(objcount);\r\n\t\t\t patternid = interactionSRHandle.pattern.cmivalue;\r\n\t\t\t u = u + \"cmi.interactions.\" + intcount + \".correct_responses.\" + objcount + \".pattern\" + equals + patternid + divider;\r\n\t\t}\r\n\r\n\r\n\t\ttimeval = intHandle.time.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".time\" + equals + timeval + divider;\r\n\r\n\t\ttypeval = intHandle.type.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".type\" + equals + typeval + divider;\r\n\r\n\t\tweightingval = intHandle.weighting.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".weighting\" + equals + weightingval + divider;\r\n\r\n\t\tstudent_responseval = intHandle.student_response.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".student_response\" + equals + student_responseval + divider;\r\n\r\n\t\tresultval = intHandle.result.cmivalue;\r\n\t\tu = u + \"cmi.interactions.\" + intcount + \".result\" + equals + resultval + divider;\r\n\r\n\t\tlatencyval = intHandle.latency.cmivalue;\r\n");
      out.write("\t\tu = u + \"cmi.interactions.\" + intcount + \".latency\" + equals + latencyval + divider;\r\n\t}\r\n\r\n\tvar alertString = titles+a+b+c+d+e+f+g+h+i+j+k+l+m+n+o+p+q+r+s+v+w+x+y+z+zz+zzz+t+u;\r\n\treturn alertString;\r\n\r\n}\r\n\r\n\r\nfunction abnormalExit(){\r\n      top.window.frames.text.location.href=\"pleasewait.htm\";\r\n}\r\n\r\n// a next/prev was clicked in this frame, so update the model before unloading\r\n// 1/2 sec delay then load the next page.\r\nfunction changeItem(scoID){\r\n    // no need to wait if already finished..\r\n    if (API.ServerSco.isInitialized == \"true\"){\r\n       top.window.frames.text.location.href=\"pleasewait.htm\"\r\n       setTimeout(\"top.window.frames.LMSFrame.location.href=\\\"LMSFrame.jsp?scoID=\"+scoID+\"\\\"\", 500);\r\n    }\r\n    else{\r\n       top.window.frames.LMSFrame.location.href=\"LMSFrame.jsp?scoID=\"+scoID;\r\n    }\r\n}\r\n\r\n/*\r\n* a function used in debug mode to see the current cmi model\r\n*/\r\nfunction viewModel(){\r\n\talert(showCurrentModelState(\"info\"));\r\n}\r\n\r\n\r\nfunction showCurrentErrorCodes(){\r\nalert(API.LMSGetLastError());\r\n");
      out.write("}\r\n\r\n/*\r\n* function which actually loads in the sco into the content \"text\" frame\r\n*/\r\nfunction loadScoContent(page){\r\n    top.window.frames.text.location.href=page;\r\n}\r\n\r\nfunction updateMainFrameAPI(){\r\n    ");
if (loadModelFlag == true){
      out.write("\r\n        loadInModel();\r\n    ");
}
      out.write("\r\n    window.top.updateAPI();\r\n    ");

    if (loadPageFlag == true){
        String url = theCourse._sequence.getLaunchFromId(scoID);
      out.write("\r\n        loadScoContent(\"");
      out.print(url);
      out.write("\");\r\n    ");
}
      out.write("\r\n}\r\n\r\n/*\r\n* -----------------------------------------------------------------------------------------------\r\n* END OF CLIENT IMPLEMENTATION\r\n* -----------------------------------------------------------------------------------------------\r\n*/\r\n//-->\r\n");
      out.write("</script>\r\n\r\n\r\n");
      out.write("<body onload=\"updateMainFrameAPI()\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n");
      out.write("<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#5a79ef\">\r\n  ");
      out.write("<tr>\r\n    ");
      out.write("<td height=\"30\">");
      out.write("<img src=\"menu-images/webtitle.gif\" width=\"664\" height=\"30\">");
      out.write("</td>\r\n  ");
      out.write("</tr>\r\n  ");
      out.write("<tr>\r\n  ");
      out.write("<td height=\"18\">\r\n  ");
      out.write("<script>\r\n  ");
      out.write("<!--\r\n  if (debug == \"true\"){\r\n    document.write(\"");
      out.write("<font size='1' face='verdana'>");
      out.write("<b>Debug Mode");
      out.write("</b>\");\r\n    document.write(\"&nbsp;&nbsp;&nbsp;|&nbsp;");
      out.write("<a href='javascript:viewModel();'>show model");
      out.write("</a>\");\r\n    document.write(\"&nbsp;&nbsp;&nbsp;|&nbsp;");
      out.write("<a href=\\\"#\\\" onclick='window.top.API.LMSFinish(\\\"\\\");'>call LMSFinish");
      out.write("</a>\");\r\n    document.write(\"&nbsp;&nbsp;&nbsp;|&nbsp;");
      out.write("<a href=\\\"#\\\" onclick='window.top.API.LMSCommit(\\\"\\\");'>call LMSCommit");
      out.write("</a>\");\r\n    document.write(\"&nbsp;&nbsp;&nbsp;|&nbsp;");
      out.write("<a href=\\\"#\\\" onclick='javascript:showCurrentErrorCodes();'>Show last error code");
      out.write("</a>\");\r\n    document.write(\"");
      out.write("</font>\");\r\n  }\r\n  //-->\r\n  ");
      out.write("</script>\r\n  ");
      out.write("</td>\r\n  ");
      out.write("</tr>\r\n  ");
      out.write("<tr>\r\n    ");
      out.write("<td bgcolor=\"#c6d7ff\">");
      out.write("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n        ");
      out.write("<tr>\r\n");
String theCurrentSco = theCourse._sequence.getCurrentSco();
      out.write("\r\n");
if (theCurrentSco == null){
      out.write("\r\n       ");
theCurrentSco = "None";
      out.write("\r\n");
}else{
      out.write("\r\n       ");
try {
      out.write("\r\n           ");
String theTitle = theCourse._sequence.getItem(theCurrentSco).getTitle();
      out.write("\r\n           ");
if (theTitle != null){
      out.write("\r\n             ");
theCurrentSco = theTitle;
      out.write("\r\n           ");
}
      out.write("\r\n       ");
}catch (Exception ex){out.print("<script language=javascript>\ngotoErrorPage();\n</script>");}
      out.write("\r\n");
}
      out.write("\r\n");
      out.write("<td>");
      out.write("<font size='2' face='verdana'>");
      out.write("<b>");
if (theCurrentSco != null){
      out.print(theCurrentSco);
}
      out.write("</b>");
      out.write("</font>");
      out.write("</td>\r\n");
if(theCourse.isNavVisible()){
      out.write("\r\n");
      out.write("<td width=\"61\">");

if (prevItem == null){
    out.print("<img src=\"menu-images/prev_disabled.gif\" width=\"61\" height=\"20\" border=\"0\">");
}
else{
out.print("<a href=\"javascript:changeItem('" + prevItem + "')\"><img src=\"menu-images/prev.gif\" width=\"61\" height=\"20\" border=\"0\"></a>");
}
      out.write("</td>\r\n");
      out.write("<td width=\"61\">");

if (nextItem == null){
    out.print("<img src=\"menu-images/next_disabled.gif\" width=\"61\" height=\"20\" border=\"0\">");
}
else{
out.print("<a href=\"javascript:changeItem('" + nextItem + "')\"><img src=\"menu-images/next.gif\" width=\"61\" height=\"20\" border=\"0\"></a>");
}
      out.write("</td>\r\n");
}
      out.write("\r\n          ");
      out.write("<td width=\"61\">");
      out.write("<a href=\"javascript:quitLMS();\">");
      out.write("<img src=\"menu-images/quit.gif\" width=\"61\" height=\"20\" border=\"0\">");
      out.write("</a>");
      out.write("</td>\r\n        ");
      out.write("</tr>\r\n        ");
      out.write("<tr bgcolor=\"#5a79ef\">\r\n          ");
      out.write("<td height=\"1\" colspan=\"4\">");
      out.write("</td>\r\n        ");
      out.write("</tr>\r\n      ");
      out.write("</table>");
      out.write("</td>\r\n  ");
      out.write("</tr>\r\n");
      out.write("</table>\r\n");
      out.write("</body>\r\n");
      out.write("</html>\r\n\r\n\r\n");
    } catch (Throwable t) {
      out = _jspx_out;
      if (out != null && out.getBufferSize() != 0)
        out.clearBuffer();
      if (pageContext != null) pageContext.handlePageException(t);
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(pageContext);
    }
  }
}
