<?xml version="1.0"?>
<xsl:stylesheet version = '1.0'  
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 xmlns:vdexns="http://www.imsglobal.org/xsd/imsvdex_v1p0"
 exclude-result-prefixes="vdexns xsi">
 
<xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>
	
	<xsl:template match="vdexns:root">
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="vdexns:vdex">
		<xsl:apply-templates select="//vdexns:vdex[vdexns:metadata]"/>			
	</xsl:template>

	<xsl:template match="//vdexns:vdex[vdexns:metadata]">
		<xsl:apply-templates select="vdexns:metadata"/>			
	</xsl:template>	
	
	<xsl:template match="vdexns:metadata">
		<xsl:apply-templates select="*|text()|@*"/>
	</xsl:template>		

	<xsl:template match="*|text()|@*">
	    <xsl:copy>
	        <xsl:apply-templates select="@*"/>
	        <xsl:apply-templates/>
	    </xsl:copy>
	</xsl:template>

</xsl:stylesheet>




